/*
 * TimeTable Viewer
 * Copyright(c)1999 by Hiroaki Sengoku <sengoku@gcd.org>
 * Version 0.1	Jun 19, 1999
 * Version 0.2	Jun 20, 1999
 * Version 0.3	Jun 20, 1999
 * Version 0.4	Jun 21, 1999
 * Version 0.5	Jun 22, 1999	AboutDialog
 * Version 0.6	Jun 25, 1999	SelectTrain, HardButton, PrefsDialog
 * Version 0.7	Jun 26, 1999	scroll bug fix
 * Version 0.8	Jul  3, 1999	Arrive, ShareReg, History, Transfer, StopClock
 * Version 0.9	Jul  8,	1999	multi '>', ContFile, CommentMark, scramble
 * Version 1.0	Jul 31, 1999	split bar, DB, ;;CANCEL, '\' esc, HeadType, LRU
 * Version 1.1	Aug 26, 1999	EvalDaysLeft, {Disp,List,Button}Prefs, Bck bit
 * Version 1.2	Aug 27, 2000	Alarm, SeparatorMap
 * Version 1.3  Aug  1, 2001	GPL version
 */
#define TTV_DIALOG
#include "Common.h"
#include "palm3.h"

/* Preference */

extern short HardButtonOverride;
extern short BorderMin;
extern short StopClockInterval;
extern short ArrivesColumn;
extern FreqType LargeClockFreq;
extern Boolean ChooseStartupFlag;
extern Boolean UnderlineSpecialFlag;
extern Boolean ScrollByKeyFlag;
extern Boolean OmitHourFlag;
extern Boolean TwelveFlag;
extern short NarrowModeDefault;
extern HeadType ArriveTimeHeadType;
extern short OfsArrive;
extern Boolean LargeClockFlag;
extern ListOrderType ListOrder;
extern InsertPosType InsertPosDB;
extern InsertPosType InsertPosMemo;

/* Table.c */
extern void drawTime(Boolean draw);

/* DB.c */
extern DmOpenRef TimeTableDB;
extern VoidHand TimeTableAppInfoH;

short DepTime;
Boolean AlarmDialogFlag;
static FormPtr AlarmFormPtr;
static Handle MidiListH = NULL;
static SndMidiListItemType *MidiListP;
static Word MidiNList;
Word MidiIndex;
static CharPtr *MidiListText;
static CharPtr *OrgItemsText;
static Word OrgNumItems;
short MinBefore;
short AlarmMinute;
Byte SeparatorMap[SeparatorMapLen];
Boolean SeparatorDirty;

static void setCheckbox(FormPtr frm, Word id, Boolean value) {
    ControlPtr control;
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,id));
    CtlSetValue(control,(short)value);
}

static Boolean getCheckbox(FormPtr frm, Word id) {
    ControlPtr control;
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,id));
    return CtlGetValue(control);
}

static void setPopup(FormPtr frm, Word id, Word lid, short item) {
    ListPtr list;
    ControlPtr control;
    Word lindex, cindex;
    RectangleType lr, cr;
    char *p;
    lindex = FrmGetObjectIndex(frm,lid);
    list = FrmGetObjectPtr(frm,lindex);
    LstSetSelection(list,item);
    cindex = FrmGetObjectIndex(frm,id);
    p = LstGetSelectionText(list,item);
    if (p) {
	control = FrmGetObjectPtr(frm,cindex);
	CtlSetLabel(control,p);
    }
    FrmGetObjectBounds(frm,cindex,&cr);
    FrmGetObjectBounds(frm,lindex,&lr);
    lr.topLeft = cr.topLeft;
    FrmSetObjectBounds(frm,lindex,&lr);
}

static short getPopup(FormPtr frm, Word lid) {
    ListPtr list;
    list = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,lid));
    return (short)LstGetSelection(list);
}

/* About Dialogue */

static void doAboutDialog(void) {
    FormPtr frm;
    ControlPtr ctl;
    VoidHand text;
    CharPtr titleStr = NULL;
    CharPtr p, q;
    frm = FrmInitForm(AboutDialog);
    text = DmGetResource('tver',1000);
    if (text) {
	q = MemHandleLock(text);
	ctl = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,AboutLabelTitle));
	p = CtlGetLabel(ctl);
	titleStr = MemPtrNew(StrLen(p)+StrLen(q)+1);
	if (titleStr) {
	    StrCopy(titleStr,p);
	    StrCat(titleStr,q);
	    CtlSetLabel(ctl,titleStr);
	}
	MemHandleUnlock(text);
	DmReleaseResource(text);
    }
    (void)FrmDoDialog(frm);
    FrmDeleteForm(frm);
    if (titleStr) MemPtrFree(titleStr);
}

/* Prefs Dialogue */

static void doDispPrefsDialog(void) {
    FormPtr frm;
    Word button;
    frm = FrmInitForm(PrefsDispDialog);
    setPopup(frm,PrefsPopupLargeClock,PrefsPopupListLargeClock,LargeClockFreq);
    setPopup(frm,PrefsPopupArriveTimeHead,PrefsPopupListArriveTimeHead,
	     ArriveTimeHeadType);
    setCheckbox(frm,PrefsCheckboxUnderline,UnderlineSpecialFlag);
    setCheckbox(frm,PrefsCheckboxOmitHour,OmitHourFlag);
    setCheckbox(frm,PrefsCheckboxNarrow,NarrowModeDefault >= 0);
    setCheckbox(frm,PrefsCheckboxTwelve,TwelveFlag);
    setPopup(frm,PrefsPopupArrivesColumn,PrefsPopupListArrivesColumn,
	     ArrivesColumn-1);
    button = FrmDoDialog(frm);
    if (button == PrefsDispOK) {
	LargeClockFreq = getPopup(frm,PrefsPopupListLargeClock);
	UnderlineSpecialFlag = getCheckbox(frm,PrefsCheckboxUnderline);
	OmitHourFlag = getCheckbox(frm,PrefsCheckboxOmitHour);
	NarrowModeDefault = (getCheckbox(frm,PrefsCheckboxNarrow) ? 0 : -1);
	TwelveFlag = getCheckbox(frm,PrefsCheckboxTwelve);
	ArrivesColumn = getPopup(frm,PrefsPopupListArrivesColumn) + 1;
	ArriveTimeHeadType = getPopup(frm,PrefsPopupListArriveTimeHead);
    }
    FrmDeleteForm(frm);
}

static short getSeparator(Byte *p, short max) {
    short i, j, len;
    Byte k;
    len = 0;
    for (i=0; i < SeparatorMapLen; i++) {
	k = 0x80;
	for (j = 0; j < 8 && len < max; j++) {
	    if (SeparatorMap[i] & k) {
		if (p) p[len] = ((i << 3) | j) + ' ';
		len++;
	    }
	    k >>= 1;
	}
    }
    if (p) p[len] = '\0';
    return len;
}

static void setSeparator(Byte *p) {
    Byte c;
    short i;
    for (i=0; i < SeparatorMapLen; i++) SeparatorMap[i] = 0;
    while (*p) {
	c = *p++;
	c -= ' ';
	SeparatorMap[c >> 3] |= (0x80 >> (c & 0x7));
    }
}

static void doListPrefsDialog(void) {
    FormPtr frm;
    Word button;
    Err err;
    UInt cardNo;
    LocalID dbID;
    UInt attr;
    Boolean backup;
    FieldPtr fld;
    FieldAttrType fld_attr;
    Word separatorIndex;
    VoidHand text;
    Byte *p;
    frm = FrmInitForm(PrefsListDialog);
    setCheckbox(frm,PrefsCheckboxStartup,ChooseStartupFlag);
    setPopup(frm,PrefsPopupSort,PrefsPopupListSort,ListOrder);
    setPopup(frm,PrefsPopupInsertDB,PrefsPopupListInsertDB,InsertPosDB);
    setPopup(frm,PrefsPopupInsertMemo,PrefsPopupListInsertMemo,InsertPosMemo);
    err = DmOpenDatabaseInfo(TimeTableDB,&dbID,NULL,NULL,&cardNo,NULL);
    if (!err) {
	err = DmDatabaseInfo(cardNo,dbID,NULL,&attr,NULL,NULL,NULL,
			     NULL,NULL,NULL,NULL,NULL,NULL);
    }
    if (err) {
	PrivErrDisplay("Can't get Database Info",false);
	backup = false;
    } else {
	backup = (attr & dmHdrAttrBackup) != 0;
    }
    setCheckbox(frm,PrefsCheckboxBackup,backup);
    SeparatorDirty = false;
    separatorIndex = FrmGetObjectIndex(frm,PrefsFieldSeparator);
    text = MemHandleNew(STRMAX+1);
    if (text) {
	p = MemHandleLock(text);
	getSeparator(p,STRMAX);
	MemHandleUnlock(text);
	fld = FrmGetObjectPtr(frm,separatorIndex);
	FldSetText(fld,text,0,STRMAX+1);
    } else {
	PrivErrExtraStr = "doListPrefsDialog: Separator text";
	PrivErrDisplay(PrivErrString(privErrNotEnoughSpace),true);
    }
    button = FrmDoDialog(frm);
    if (button == PrefsListOK) {
	ChooseStartupFlag = getCheckbox(frm,PrefsCheckboxStartup);
	ListOrder = getPopup(frm,PrefsPopupListSort);
	InsertPosDB = getPopup(frm,PrefsPopupListInsertDB);
	if (TimeTableAppInfoH) {
	    TimeTableAppInfoType *appInfoP, *nilP = 0;
	    appInfoP = MemHandleLock(TimeTableAppInfoH);
	    if ((appInfoP->sortOrder
		 && InsertPosDB != InsertPosAlphabetical)
		|| (!appInfoP->sortOrder
		    && InsertPosDB == InsertPosAlphabetical)) {
		Byte sortOrder = !appInfoP->sortOrder;
		DmWrite(appInfoP,(ULong)&nilP->sortOrder,
			&sortOrder,sizeof(sortOrder));
	    }
	    MemHandleUnlock(TimeTableAppInfoH);
	}
	InsertPosMemo = getPopup(frm,PrefsPopupListInsertMemo);
	if (!err
	    && (backup ^ (getCheckbox(frm,PrefsCheckboxBackup) != 0))) {
	    attr ^= dmHdrAttrBackup;
	    err = DmSetDatabaseInfo(cardNo,dbID,NULL,&attr,NULL,NULL,NULL,
				      NULL,NULL,NULL,NULL,NULL,NULL);
	    if (err) PrivErrDisplay("Can't set Database Info",false);
	}
	fld = FrmGetObjectPtr(frm,separatorIndex);
	FldGetAttributes(fld,&fld_attr);
	if (fld_attr.dirty) {
	    SeparatorDirty = true;
	    setSeparator(FldGetTextPtr(fld));
	}
    }
    FrmDeleteForm(frm);
}

static void doButtonPrefsDialog(void) {
    FormPtr frm;
    Word button;
    short item;
    frm = FrmInitForm(PrefsButtonDialog);
    if (HardButtonOverride < 0) {
	item = 5;	/* Always */
    } else if (HardButtonOverride == 0) {
	item = 0;	/* Never */
    } else if (0 < HardButtonOverride && HardButtonOverride <= 2) {
	item = 1;	/* 2 sec */
    } else if (2 < HardButtonOverride && HardButtonOverride <= 4) {
	item = 2;	/* 4 sec */
    } else if (4 < HardButtonOverride && HardButtonOverride <= 8) {
	item = 3;	/* 8 sec */
    } else if (8 < HardButtonOverride && HardButtonOverride <= 16) {
	item = 4;	/* 16 sec */
    } else {
	item = 3;	/* default */
    }
    setPopup(frm,PrefsPopupHardButton,PrefsPopupListHardButton,item);
    if (BorderMin == -3) {
	item = 0;	/* both */
    } else if (BorderMin == -2) {
	item = 5;	/* PM fix */
    } else if (BorderMin == -1) {
	item = 1;	/* AM fix */
    } else if (BorderMin <= 630) {
	item = 2;	/* 10:00 */
    } else if (BorderMin <= 675) {
	item = 3;	/* 11:00 */
    } else if (BorderMin <= 705) {
	item = 4;	/* 11:30 */
    } else if (BorderMin <= 735) {
	item = 6;	/* 12:00 */
    } else if (BorderMin <= 765) {
	item = 7;	/* 12:30 */
    } else if (BorderMin <= 795) {
	item = 8;	/* 13:00 */
    } else if (BorderMin <= 825) {
	item = 9;	/* 13:30 */
    } else if (BorderMin <= 870) {
	item = 10;	/* 14:00 */
    } else if (BorderMin <= 930) {
	item = 11;	/* 15:00 */
    } else {
	item = 12;	/* 16:00 */
    }
    setPopup(frm,PrefsPopupAMPM,PrefsPopupListAMPM,item);
    setPopup(frm,PrefsPopupStopClock,PrefsPopupListStopClock,
	     StopClockInterval);
    setCheckbox(frm,PrefsCheckboxScroll,ScrollByKeyFlag);
    button = FrmDoDialog(frm);
    if (button == PrefsButtonOK) {
	item = getPopup(frm,PrefsPopupListHardButton);
	if (item != noListSelection) {
	    switch (item) {
	    case 0:  HardButtonOverride = 0;   break;
	    case 1:  HardButtonOverride = 2;   break;
	    case 2:  HardButtonOverride = 4;   break;
	    case 3:  HardButtonOverride = 8;   break;
	    case 4:  HardButtonOverride = 16;  break;
	    case 5:  HardButtonOverride = -1;  break;
	    }
	}
	item = getPopup(frm,PrefsPopupListAMPM);
	if (item != noListSelection) {
	    switch (item) {
	    case 0:  BorderMin = -3;  break;
	    case 1:  BorderMin = -1;  break;
	    case 2:  BorderMin = 600;  break;
	    case 3:  BorderMin = 660;  break;
	    case 4:  BorderMin = 690;  break;
	    case 5:  BorderMin = -2;  break;
	    case 6:  BorderMin = 720;  break;
	    case 7:  BorderMin = 750;  break;
	    case 8:  BorderMin = 780;  break;
	    case 9:  BorderMin = 810;  break;
	    case 10: BorderMin = 840;  break;
	    case 11: BorderMin = 900;  break;
	    case 12: BorderMin = 960;  break;
	    }
	}
	StopClockInterval = getPopup(frm,PrefsPopupListStopClock);
	ScrollByKeyFlag = getCheckbox(frm,PrefsCheckboxScroll);
    }
    FrmDeleteForm(frm);
}

/* Global variables can't be used in this function */
static void playAlarmSound(ULong recID, LocalID dbID, UInt cardNo) {
    DmOpenRef dbP = NULL;
    UInt index;
    Err err;
    VoidHand midiH;
    SndMidiRecHdrType* midiHdrP;
    BytePtr midiStreamP;
    SndSmfOptionsType smfOpt;
    dbP = DmOpenDatabase(cardNo,dbID,dmModeReadOnly);
    if (!dbP) goto error;
    err = DmFindRecordByID(dbP,recID,&index);
    if (err) goto error;
    midiH = DmQueryRecord(dbP,index);
    midiHdrP = MemHandleLock(midiH);
    midiStreamP = (BytePtr)midiHdrP + midiHdrP->bDataOffset;
    smfOpt.dwStartMilliSec = 0;
    smfOpt.dwEndMilliSec = sndSmfPlayAllMilliSec;
    smfOpt.amplitude = (UInt)PrefGetPreference(prefAlarmSoundVolume);
    smfOpt.interruptible = true;
    smfOpt.reserved = 0;
    err = SndPlaySmf(NULL,sndSmfCmdPlay,midiStreamP,&smfOpt,NULL,NULL,false);
    MemHandleUnlock(midiH);
    DmCloseDatabase(dbP);
    return;
 error:
    if (dbP) DmCloseDatabase(dbP);
    SndPlaySystemSound(sndAlarm);
}

static void setHour(FormPtr frm, short hour) {
    ControlPtr control;
    static char str[3];
    str[0] = '0'+hour/10;
    str[1] = '0'+hour%10;
    str[2] = '\0';
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,AlarmButtonHour));
    if (control) CtlSetLabel(control,str);
}

static void setMinute(FormPtr frm, short d, short num) {
    ControlPtr control;
    Word id;
    static char str[4];
    if (d == 0) {
	id = AlarmButtonMinD;
	str[0] = '0'+num;
	str[1] = '\0';
    } else {
	id = AlarmButtonMinO;
	str[2] = '0'+num;
	str[3] = '\0';
    }
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,id));
    if (control) CtlSetLabel(control,&str[d*2]);
}

static short getNumber(FormPtr frm, Word id) {
    ControlPtr control;
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,id));
    if (control) return StrAToI(CtlGetLabel(control));
    return -1;
}

static void setHourMinute(FormPtr frm, short min) {
    short hour;
    if (min < 0) min += 24 * 60;
    hour = (min / 60) % 24;
    min = min % 60;
    setHour(frm,hour);
    setMinute(frm,0,min/10);
    setMinute(frm,1,min%10);
}

static short getMinBefore(FormPtr frm) {
    short item = getPopup(frm,AlarmPopupListBefore);
    switch (item) {
    case 0:	return 1;
    case 1:	return 3;
    case 2:	return 5;
    case 3:	return 10;
    case 4:	return 15;
    case 5:	return 20;
    case 6:	return 25;
    case 7:	return 30;
    default:	return 3;
    }
}

static Boolean openAlarmDialog(FormPtr frm) {
    static char str[6];
    Word index;
    ListPtr list;
    ControlPtr control;
    short width, widthMax;
    short item;
    short hour, min;
    short i;
    if (!frm) return false;
    if (MidiListH == NULL
	&& !SndCreateMidiList(0,true,&MidiNList,&MidiListH)) {
	MidiListH = NULL;
	PrivErrDisplay("No MIDIrecords found",false);
	return false;
    }
    MidiListText = MemPtrNew(sizeof(CharPtr) * MidiNList);
    if (!MidiListText) {
	PrivErrDisplay(PrivErrString(privErrNotEnoughSpace),true);
	return false;
    }
    index = FrmGetObjectIndex(frm,AlarmPopupListMidi);
    list = FrmGetObjectPtr(frm,index);
    OrgItemsText = list->itemsText;	/* save original */
    OrgNumItems = list->numItems;
    list->itemsText = MidiListText;	/* modify */
    list->numItems = MidiNList;
    MidiListP = MemHandleLock((VoidHand)MidiListH);
    widthMax = 0;
    for (i=0; i < MidiNList; i++) {
	MidiListText[i] = MidiListP[i].name;
	width = FntCharsWidth(MidiListText[i],StrLen(MidiListText[i]));
	if (width > widthMax) widthMax = width;
    }
    list->bounds.extent.x = widthMax + 15;
    list->bounds.extent.y = FntCharHeight() * (MidiNList > 8 ? 8 : MidiNList);
    if (MidiIndex >= MidiNList) MidiIndex = 0;
    setPopup(frm,AlarmPopupMidi,AlarmPopupListMidi,MidiIndex);
    if (MinBefore <= 1) item = 0;
    else if (MinBefore <= 3) item = 1;
    else if (MinBefore <= 7) item = 2;
    else if (MinBefore <= 12) item = 3;
    else if (MinBefore <= 17) item = 4;
    else if (MinBefore <= 22) item = 5;
    else if (MinBefore <= 27) item = 6;
    else item = 7;
    setPopup(frm,AlarmPopupBefore,AlarmPopupListBefore,item);
    setHourMinute(frm,DepTime - MinBefore);
    hour = (DepTime / 60) % 24;
    min = DepTime % 60;
    digit2str(hour,str,true);
    str[2] = ':';
    digit2str(min,&str[3],true);
    control = FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,AlarmLabelDepTime));
    if (control) CtlSetLabel(control,str);
    return true;
}

static void closeAlarmDialog(FormPtr frm) {
    Word index;
    ListPtr list;
    index = FrmGetObjectIndex(frm,AlarmPopupListMidi);
    list = FrmGetObjectPtr(frm,index);
    list->itemsText = OrgItemsText;	/* restore */
    list->numItems = OrgNumItems;
    MidiListP = NULL;
    MemHandleUnlock((VoidHand)MidiListH);
    MemHandleFree((VoidHand)MidiListH);
    MidiListH = NULL;
    MemPtrFree(MidiListText);
    MidiListText = NULL;
}

static short getAlarm(void) {
    UInt cardNo;
    LocalID dbID;
    DWord ref;
    ULong sec;
    DmSearchStateType searchInfo;
    DmGetNextDatabaseByTypeCreator(true,&searchInfo,
				   sysFileTApplication,APPID,
				   true,&cardNo,&dbID);
    sec = AlmGetAlarm(cardNo,dbID,&ref);
    if (sec) {
	DateTimeType dateTime;
	TimSecondsToDateTime(sec,&dateTime);
	return dateTime.hour * 60 + dateTime.minute;
    }
    return -1;
}

static Boolean setAlarm(short minute) {
    UInt cardNo;
    LocalID dbID;
    DmSearchStateType searchInfo;
    SndMidiListItemType *p;
    Boolean midiListHFlag = false;
    Boolean midiListPFlag = false;
    DWord ref = 0;
    TimeTableAppInfoType *appInfoP, *nilP = 0;
    struct appInfo {
	ULong alarmRecID;
	LocalID alarmDbID;
	UInt alarmCardNo;
    } info;
    ULong now = TimGetSeconds();
    ULong alarm;
    DateTimeType dateTime;
    short min;
    if (minute >= 0) {
	TimSecondsToDateTime(now,&dateTime);
	min = minute - (dateTime.hour * 60 + dateTime.minute);
	if (min < 0) min += 24 * 60;
	if (min >= AlarmMinuteMax) {
	    AlarmMinute = -1;
	    return false;
	}
	now -= dateTime.second;
	AlarmMinute = minute;
	alarm = now + (ULong)min * 60L;
    } else {
	AlarmMinute = -1;
	alarm = 0;
    }
    DmGetNextDatabaseByTypeCreator(true,&searchInfo,
				   sysFileTApplication,APPID,
				   true,&cardNo,&dbID);
    if (alarm) {
	if (MidiListP == NULL) {
	    if (MidiListH == NULL) {
		if (!SndCreateMidiList(0,true,&MidiNList,&MidiListH)) {
		    MidiListH = NULL;
		    PrivErrDisplay("No MIDIrecords found",false);
		    return false;
		}
		midiListHFlag = true;
	    }
	    MidiListP = MemHandleLock((VoidHand)MidiListH);
	    midiListPFlag = true;
	}
	p = MidiListP + MidiIndex;
	info.alarmRecID = p->uniqueRecID;
	info.alarmDbID = p->dbID;
	info.alarmCardNo = p->cardNo;
	if (midiListPFlag) {
	    MidiListP = NULL;
	    MemHandleUnlock((VoidHand)MidiListH);
	}
	if (midiListHFlag) {
	    MemHandleFree((VoidHand)MidiListH);
	    MidiListH = NULL;
	}
	if (!TimeTableAppInfoH) {
	    PrivErrDisplay("Can't find AppInfo",false);
	    return false;
	}
	appInfoP = MemHandleLock(TimeTableAppInfoH);
	DmWrite(appInfoP,(ULong)&nilP->alarmRecID,&info,sizeof(info));
	MemHandleUnlock(TimeTableAppInfoH);
    }
    AlmSetAlarm(cardNo,dbID,ref,alarm,true);
    return true;
}

static Boolean AlarmDialogHandleEvent(EventPtr e) {
    static short alarmPart;
    Boolean handled = false;
    short i;

    CALLBACK_PROLOGUE

    switch (e->eType) {
    case frmOpenEvent:
	AlarmFormPtr = FrmGetFormPtr(AlarmDialog);
	if (openAlarmDialog(AlarmFormPtr)) {
	    AlarmDialogFlag = true;
	    FrmDrawForm(AlarmFormPtr);
	    alarmPart = -1;
	    handled = true;
	}
	break;
    case frmCloseEvent:
	closeAlarmDialog(AlarmFormPtr);
	AlarmDialogFlag = false;
	AlarmFormPtr = NULL;
    /*	handled = false;  Let the system to delete the current form */
	break;
    case ctlSelectEvent:
	switch(e->data.ctlSelect.controlID) {
	case AlarmOK:
	    MidiIndex = getPopup(AlarmFormPtr,AlarmPopupListMidi);
	    MinBefore = getMinBefore(AlarmFormPtr);
	    if (!setAlarm(getNumber(AlarmFormPtr,AlarmButtonHour) * 60
			  + getNumber(AlarmFormPtr,AlarmButtonMinD) * 10
			  + getNumber(AlarmFormPtr,AlarmButtonMinO)))
		goto play;
	    handled = true;
	close:
	    closeAlarmDialog(AlarmFormPtr);
	    AlarmDialogFlag = false;
	    AlarmMinute = getAlarm();
	    AlarmFormPtr = NULL;
	    FrmReturnToForm(0);
	    break;
	case AlarmCancel:
	    handled = true;
	    goto close;
	case AlarmPlay:
	play:
	    {
		SndMidiListItemType *p;
		p = MidiListP + getPopup(AlarmFormPtr,AlarmPopupListMidi);
		playAlarmSound(p->uniqueRecID,p->dbID,p->cardNo);
	    }
	    handled = true;
	    break;
	case AlarmButtonHour:
	    alarmPart = 0;
	    handled = true;
	    break;
	case AlarmButtonMinD:
	    alarmPart = 1;
	    handled = true;
	    break;
	case AlarmButtonMinO:
	    alarmPart = 2;
	    handled = true;
	    break;
	case AlarmButtonUp:
	upbutton:
	    i = 1;
	updown:
	    switch (alarmPart) {
	    case 0:
		i += getNumber(AlarmFormPtr,AlarmButtonHour);
		if (i < 0) i += 24;
		else if (i >= 24) i -= 24;
		setHour(AlarmFormPtr,i);
		break;
	    case 1:
		i += getNumber(AlarmFormPtr,AlarmButtonMinD);
		if (i < 0) i += 6;
		else if (i >= 6) i -= 6;
		setMinute(AlarmFormPtr,0,i);
		break;
	    case 2:
		i += getNumber(AlarmFormPtr,AlarmButtonMinO);
		if (i < 0) i += 10;
		else if (i >= 10) i -= 10;
		setMinute(AlarmFormPtr,1,i);
		break;
	    default:
		i = getPopup(AlarmFormPtr,AlarmPopupListBefore) - i;
		if (0 <= i && i <= 7) {
		    setPopup(AlarmFormPtr,AlarmPopupBefore,
			     AlarmPopupListBefore,i);
		    setHourMinute(AlarmFormPtr,
				  DepTime - getMinBefore(AlarmFormPtr));
		}
		break;
	    }
	    handled = true;
	    break;
	case AlarmButtonDown:
	downbutton:
	    i = -1;
	    goto updown;
	    break;
	}
	break;
    case popSelectEvent:
	if (e->data.popSelect.listID == AlarmPopupListBefore) {
	    setHourMinute(AlarmFormPtr,DepTime - getMinBefore(AlarmFormPtr));
	}
	break;
    case keyDownEvent:
	if (e->data.keyDown.chr == pageUpChr) {
	    goto upbutton;
	} else if (e->data.keyDown.chr == pageDownChr) {
	    goto downbutton;
	}
	break;
    case nilEvent:
	drawTime(true);
	break;
    default:
	break;
    }

    CALLBACK_EPILOGUE

    return handled;
}

/* Global variables can't be used in this function */
void stepAlarmTriggered(SysAlarmTriggeredParamType *cmdPBP,
			ULong recID, LocalID dbID, UInt cardNo) {
    if (dbID) {
	playAlarmSound(recID,dbID,cardNo);
    } else {
	SndPlaySystemSound(sndAlarm);
    }
}
