/*
 * TimeTable Viewer
 * Copyright(c)1999 by Hiroaki Sengoku <sengoku@gcd.org>
 * Version 0.1	Jun 19, 1999
 * Version 0.2	Jun 20, 1999
 * Version 0.3	Jun 20, 1999
 * Version 0.4	Jun 21, 1999
 * Version 0.5	Jun 22, 1999	AboutDialog
 * Version 0.6	Jun 25, 1999	SelectTrain, HardButton, PrefsDialog
 * Version 0.7	Jun 26, 1999	scroll bug fix
 * Version 0.8	Jul  3, 1999	Arrive, ShareReg, History, Transfer, StopClock
 * Version 0.9	Jul  8,	1999	multi '>', ContFile, CommentMark, scramble
 * Version 1.0	Jul 31, 1999	split bar, DB, ;;CANCEL, '\' esc, HeadType, LRU
 * Version 1.1 	Aug 26, 1999	move DB
 * Version 1.2	Jan  1, 2000	BorderMin, blink colon, ;;PREC, DotPattern
 * Version 1.2b	Aug 30, 2000	TwelveFlag
 * Version 1.3  Aug  1, 2001	GPL version
 */
#include "Common.h"

/* Main.c */
extern Boolean menuAppear(void);
extern ULong LastSec;
extern MenuBarPtr CurrentMenuBar;

/* DB.c */
extern void disposeTimeTable(TimeTableType *table);
extern Boolean checkTitle(long recordNum, char *title);
extern long searchFile(char *p);
extern long searchTransfer(char *p, short *ofs);
extern long moveRecord(long src, short nconts);
extern TimeTableType *CurrentTable;
extern char Title[];
extern short NContFiles;
extern WeekType Today;
extern ULong TodaySetSeconds;
extern Word DotPattern[0x11111+1];
extern SByte NarrowList[];

/* Dialog.c */
extern short DepTime;
extern Boolean AlarmDialogFlag;
extern short AlarmMinute;

static FormPtr MainFormPtr;
static ULong PrevTime;
#define ArrivesColumnMax	10
short *ArriveTime;
static short ArriveTimeHead[ArrivesColumnMax];
static Byte ArriveTimeHeadMark[ArrivesColumnMax];
short ArrivesColumn;
/* char, ..., '\0', SByte comment, ..., SByte -1, short minute */
/* char *ArrivesBuf; */
short OfsArrive;
Boolean ShowArrivesFlag;
static Boolean ArriveBarFlag;
static short ArriveRightX;

static WinHandle OffScreen;
static Word OffScreenErr;
#define ScreenX		160
#define ScreenY		160
static short TableX;	/* [pixel] */
static short TableY;
static short TopY;
static short TimeLeftX;
static short TimeLeftColonX;
static short BoldColonWidth;
static Word BlackPattern[] = {0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF};
static RectangleType NormalClockRect;

#define TableRightX	(TableX+HourWidth+ItemWidth*NItems)
#define TableBottomY	(TableY+ItemHeight*NLines)
#define SpaceWidth	3
short NItems;	/* [cell] */
short NLines;
#define NLinesMin	3
#define NLinesMax	((LargeClockY-TableY) / ItemHeight)
static short OfsItem;
static short OfsLine;
short SelItem;
short SelLine;
short TransNLines;
static SByte CommentsTmp[ExCommentsMax];
#define CommBottomY	(TransNLines ? (ScreenY-CommentsHeight*TransNLines-1)\
			 : ScreenY)
#define NShowComments	((CommBottomY-TableBottomY)/CommentsHeight)
Boolean ShowCommentsFlag;
Boolean UnderlineSpecialFlag;
Boolean ScrollByKeyFlag;
#define HourWidth	(ItemWidth+2)
static short ItemWidth;	/* [pixel] */
static short ItemHeight;
#define CommentsHeight	(ItemHeight-1)
short TimeX;
short TimeY;
static short TimeWidth;
static short TimeHeight;
Boolean TwelveFlag;

Boolean ManualSelectFlag;
Boolean DrawNotesFlag;
Boolean SelectCurrentFlag;
short NextTrain;
short SelectTrain;
static short FirstTrain;
static short LastTrain;

#define NumBitmapX	24
#define NumBitmapY	39
#define ColonBitmapX	11
#define NNumBitmaps	12
VoidHand NumBitmap[NNumBitmaps];
VoidHand AlarmBitmap;
#define AlarmSize	13
static RectangleType AlarmRect;
static short AlarmTapCount;
#define AlarmTapCountMax	3;	/* 3 sec */
static short AlarmMinuteSave;
#define LargeClockX	(ScreenX-NumBitmapX*4-ColonBitmapX)
#define LargeClockY	(ScreenY-NumBitmapY)
#define LargeClockLines	(NumBitmapY/CommentsHeight+1)
Boolean LargeClockFlag;
FreqType LargeClockFreq;
#define LargeClockMin	(-10*60)
Boolean ClockInvertedFlag;
ULong StopClock;
short StopClockInterval;
Word TicksPerSeconds;

HeadType ArriveTimeHeadType;
short NarrowMode;
short NarrowModeDefault;
static RectangleType NarrowPopupRect;
static CharPtr *NarrowOrgItemsText;
static Word NarrowOrgNumItems;
static short NarrowOrgItemWidth;
static short NarrowEndX;
Boolean OmitHourFlag;
Boolean ChooseStartupFlag;
static Boolean StartupFlag;
static short StnX;
static short StnXLower;
static short StnExtent;

MenuBarPtr MainMenuBar;
FileMenuType FileMenu[MENU_NITEMS*2];
short BorderMin;	/* -3:Both, -2:PM, -1:AM, 0-:minute */
static VoidHand MoveMenuItemStrH;

LRU_Type LRU[LRU_MAX];
short LRU_Top;
long TrainTimeRecordNum;

long History[HISTORYMAX];
HisAttrType HisAttr[HISTORYMAX];
short HistoryTop;
short HistoryCur;
short HistoryBot;
RectangleType BackwardButtonRect, ForwardButtonRect;

static void updateOptionMenuItem(void) {
    MenuItemType *item;
    if (MoveMenuItemStrH) {
	MemHandleUnlock(MoveMenuItemStrH);
	DmReleaseResource(MoveMenuItemStrH);
    }
    if (TrainTimeRecordNum >= TimeTableRecordNumMin) {
	MoveMenuItemStrH = DmGetResource('tSTR',MoveDBToMemoStr);
    } else {
	MoveMenuItemStrH = DmGetResource('tSTR',MoveMemoToDBStr);
    }
    if (!MoveMenuItemStrH) return;
    item = MainMenuBar->menus[1].items;
    item[5].itemStr = MemHandleLock(MoveMenuItemStrH);
}

static void unselectItem(void) {
    SelItem = SelLine = -1;
    SelectTrain = -1;
    SelectCurrentFlag = false;
    ManualSelectFlag = false;	/* automatically unselected */
}

static void saveHisAttr(short pos) {
    if (pos < 0 || HISTORYMAX <= pos) {
	PrivErrDisplay("Can't happen: saveHisAttr: pos is out of range",false);
	return;
    }
#ifdef DEBUG
    HostFPrintF(HostFp,"saveHisAttr: %ld, ManualSelectFlag %d\n",
		History[pos],ManualSelectFlag);
#endif
    HisAttr[pos].StopClock = StopClock;
    HisAttr[pos].ManualSelectFlag = ManualSelectFlag;
    if (ManualSelectFlag) {
	HisAttr[pos].SelItem = SelItem;
	HisAttr[pos].SelLine = SelLine;
    } else {
	HisAttr[pos].SelItem = -1;
	HisAttr[pos].SelLine = -1;
    }
}

static void restoreHisAttr(short pos) {
    StopClock = HisAttr[pos].StopClock;
    ManualSelectFlag = HisAttr[pos].ManualSelectFlag;
    if (ManualSelectFlag) {
	SelItem = HisAttr[pos].SelItem;
	SelLine = HisAttr[pos].SelLine;
    } else {
	unselectItem();
    }
#ifdef DEBUG
    HostFPrintF(HostFp,"restoreHisAttr: %ld, ManualSelectFlag %d\n",
		History[pos],ManualSelectFlag);
#endif
}

static long backHistory(void) {
    ULong time;
    short cur;
    cur = HistoryCur - 1;
    if (cur < 0) cur += HISTORYMAX;
    if (cur == HistoryBot) return -1;
    time = TimGetSeconds();
    restoreHisAttr(cur);
    if (StopClock <= time) StopClock = 0;
    return History[HistoryCur=cur];
}

static long forwardHistory(void) {
    ULong time;
    if (HistoryCur == HistoryTop) return -1;
    HistoryCur++;
    if (HistoryCur >= HISTORYMAX) HistoryCur -= HISTORYMAX;
    time = TimGetSeconds();
    restoreHisAttr(HistoryCur);
    if (StopClock <= time) StopClock = 0;
    return History[HistoryCur];
}

static short pushHistory(long record, short ins) {
    short pos;
    Boolean top = false;
    if (History[ins] == record) return ins;
    if (ins == HistoryTop) top = true;
    pos = ins + 1;
    if (pos >= HISTORYMAX) pos -= HISTORYMAX;
    if (pos == HistoryCur) return ins;	/* overflow */
    if (top) {
	HistoryTop = pos;
	if (HistoryBot == pos) {
	    HistoryBot++;	/* remove oldest */
	    if (HistoryBot >= HISTORYMAX) HistoryBot -= HISTORYMAX;
	}
    } else {
	if (History[pos] != record) HistoryTop = pos;
    }
    History[pos] = record;
    return pos;
}

static void storeHistory(long record) {
    HistoryCur = pushHistory(record,HistoryCur);
}

static void shiftHistory(long record) {
    short i;
    for (i=0; i < HISTORYMAX; i++) {
	if (record >= TimeTableRecordNumMin
	    || History[i] < TimeTableRecordNumMin) {
	    if (History[i] >= record) History[i]++;
	}
    }
}

static void initLRU(void) {
    short i;
    for (i=0; i < LRU_MAX; i++) {
	LRU[i].next = i+1;
	LRU[i].recordNum = -1;
    }
    LRU[LRU_MAX-1].next = -1;
    LRU_Top = 0;
}

static Boolean getLRU(long record) {
    short i, j, p, q;
#ifdef DEBUG
    HostFPrintF(HostFp,"getLRU(%ld) in:",record);
    for (i=LRU_Top; i >= 0 && LRU[i].recordNum >= 0; i=LRU[i].next)
	HostFPrintF(HostFp," %ld",LRU[i].recordNum);
    HostFPrintF(HostFp,"\n");
#endif
    p = q = -1;
    j = 0;
    for (i=LRU_Top; i >= 0; i=LRU[i].next) {
	if (LRU[i].recordNum == record) {
	    if (p >= 0) {
		LRU[p].next = LRU[i].next;
		LRU[i].next = LRU_Top;
		LRU_Top = i;
	    }
#ifdef DEBUG
	    HostFPrintF(HostFp,"getLRU(%ld) out:",record);
	    for (i=LRU_Top; i >= 0 && LRU[i].recordNum >= 0; i=LRU[i].next)
		HostFPrintF(HostFp," %ld",LRU[i].recordNum);
	    HostFPrintF(HostFp,"\n");
#endif
	    return true;
	}
	q = p;
	p = i;
	j++;
    }
    if (q >= 0 && p >= 0 && j == LRU_MAX) {
	LRU[q].next = LRU[p].next;	/* not found */
	LRU[p].next = LRU_Top;
	LRU_Top = p;
    } else {
	PrivErrDisplay("Can't happen: LRU shorten",false);
	initLRU();
    }
    LRU[LRU_Top].recordNum = record;
    LRU[LRU_Top].OfsArrive = 0;
    LRU[LRU_Top].ShowArrivesFlag = ShowArrivesFlag;
    LRU[LRU_Top].NarrowMode = NarrowModeDefault;
    LRU[LRU_Top].NLines = NLines;
#ifdef DEBUG
    HostFPrintF(HostFp,"getLRU(%ld) out:",record);
    for (i=LRU_Top; i >= 0 && LRU[i].recordNum >= 0; i=LRU[i].next)
	HostFPrintF(HostFp," %ld",LRU[i].recordNum);
    HostFPrintF(HostFp,"\n");
#endif
    return false;
}

static void putLRU(void) {
    if (LRU_Top < 0) {
	PrivErrDisplay("Can't happen: LRU_Top < 0",false);
	initLRU();
	LRU[LRU_Top].recordNum = TrainTimeRecordNum;
    }
#ifdef DEBUG
    HostFPrintF(HostFp,"putLRU: %ld\n",LRU[LRU_Top].recordNum);
#endif
    if (LRU[LRU_Top].recordNum != TrainTimeRecordNum) {
	PrivErrDisplay("Can't happen: "
		       "LRU[LRU_Top].recordNum != TrainTimeRecordNum",false);
	getLRU(TrainTimeRecordNum);
    }
    LRU[LRU_Top].OfsArrive = OfsArrive;
    LRU[LRU_Top].ShowArrivesFlag = ShowArrivesFlag;
    LRU[LRU_Top].NarrowMode = NarrowMode;
    LRU[LRU_Top].NLines = NLines;
}

static void shiftLRU(long record) {
    short i;
    for (i=0; i < LRU_MAX; i++) {
	if (record >= TimeTableRecordNumMin
	    || LRU[i].recordNum < TimeTableRecordNumMin) {
	    if (LRU[i].recordNum >= record) LRU[i].recordNum++;
	}
    }
}

static void setFirstLastTrain(void) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short i, j;
#ifdef PROFILE
    HostFPrintF(HostFp,"setFirstLastTrain(void) %lu\n",TimGetTicks());
#endif
    FirstTrain = LastTrain = -1;
    for (i=0; i < LinesLen; i++) {
	for (j=0; j < Lines[i]->length; j++) {
	    if (FirstTrain < 0)
		FirstTrain = Lines[i]->hour * 60 + Lines[i]->items[j].minute;
	    LastTrain = Lines[i]->hour * 60 + Lines[i]->items[j].minute;
	}
    }
    if (LastTrain < FirstTrain) LastTrain += 24 * 60;
}

static Boolean loadTrainTimeDB(long recordNum) {
    short prev = NarrowMode;
    if (getLRU(recordNum)) {
	OfsArrive = LRU[LRU_Top].OfsArrive;
	ShowArrivesFlag = LRU[LRU_Top].ShowArrivesFlag;
	prev = NarrowMode = LRU[LRU_Top].NarrowMode;
	NLines = LRU[LRU_Top].NLines;
    } else {
	NarrowMode = NarrowModeDefault;
    }
    if (prev >= 0 && NarrowMode < 0) NLines++;
    else if (prev < 0 && NarrowMode >= 0) NLines--;
    if (loadDB(recordNum)) {
	TrainTimeRecordNum = recordNum;
	if (OfsArrive >= CurrentTable->ArrivesLen) OfsArrive = 0;
	updateOptionMenuItem();
	setFirstLastTrain();
	return true;
    }
    return false;
}


/* TimeTable Form */

static short xy2train(short x, short y, Boolean xyFlag) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short hour, minute;
    if (x < 0 || y < 0) return -1;
    if (xyFlag) {
	if (LinesLen <= y || Lines[y]->length <= x) return -1;
	hour = Lines[y]->hour;
	minute = Lines[y]->items[x].minute;
    } else {
	hour = y;
	minute = x;
    }
    minute += hour * 60;
    if (hour < 24) {
	if (minute + 24 * 60 < LastTrain) minute += 24 * 60;
    } else if (minute > LastTrain) {
	minute -= 24 * 60;
    }
    return minute;
}

static short minute2nextTrain(short minute, short *itemP, short *lineP) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short nextTrain;
    short hour, h, i, j, fi, fj;
    hour = minute / 60;
    if (hour < 24) {
	if (minute + 24 * 60 < LastTrain) hour += 24;
    } else if (minute >= LastTrain) {
	hour -= 24;
    }
    minute = minute % 60;
    nextTrain = -1;
    fi = fj = -1;
    for (i=0; i < LinesLen; i++) {
	for (j=0; j < Lines[i]->length; j++) {
	    if (Lines[i]->items[j].mark != CancelMark && nextTrain < 0) {
		nextTrain = xy2train(j,i,true);
		fj = j;
		fi = i;
	    }
	    h = Lines[i]->hour;
	    if (h < Lines[0]->hour) h += 24;
	    if (hour > h) continue;
	    if (Lines[i]->items[j].mark != CancelMark
		&& (hour < h
		    || minute < Lines[i]->items[j].minute)) {
		nextTrain = xy2train(j,i,true);
		if (nextTrain < FirstTrain) nextTrain += 24 * 60;
		if (itemP) *itemP = j;
		if (lineP) *lineP = i;
		return nextTrain;
	    }
	}
    }
    if (itemP) *itemP = fj;
    if (lineP) *lineP = fi;
    return nextTrain;
}

static void invertXY(short x, short y, CommentMarkType type) {	/* [pixel] */
    RectangleType r;
    short bottom = y + ItemHeight - 2;
    short left = x - 2;
    short right = left + ItemWidth - 1;
    switch (type) {
    case InvertMark:	/* invert block */
	r.topLeft.x = left;
	r.extent.x = ItemWidth;
	r.topLeft.y = y;
	r.extent.y = ItemHeight - 1;
	WinInvertRectangle(&r,0);
	break;
    case SuccMark:	/* succeeding point */
	WinInvertLine(left+2,bottom,left+4,bottom);
	break;
    case PrecMark:	/* preceeding point */
	WinInvertLine(right-4,bottom,right-2,bottom);
	break;
    case MiddleMark:	/* middle point */
	WinInvertLine(left+5,bottom,right-5,bottom);
	break;
    case Mark:		/* underline */
	WinInvertLine(left+2,bottom,right-2,bottom);
	break;
    case DotMark:	/* dotted underline */
	{
	    CustomPatternType savePattern;
	    Word dot[] = {0xAAAA, 0xAAAA, 0xAAAA, 0xAAAA};
	    WinGetPattern(savePattern);
	    WinSetPattern(dot);
	    WinFillLine(left+2,bottom,right-2,bottom);
	    WinSetPattern(savePattern);
	}
	break;
    case DDotMark:	/* double dotted underline */
	WinInvertLine(left+2,bottom,left+4,bottom);
	WinInvertLine(right-4,bottom,right-2,bottom);
	break;
    case CancelMark:	/* cancel line */
	WinInvertLine(left,y+ItemHeight/2-1,right,y+ItemHeight/2-1);
	break;
    default:
	if (Mark00000 <= type && type <= Mark11111) {
	    short dot = DotPattern[type-Mark00000];
	    short len = right - left + 1;
	    short pat;
	    x = left;
	    left = -1;
	    pat = (1 << len);
#ifdef DEBUG
	    HostFPrintF(HostFp,"invertXY: mark%x, %2x:",type-Mark00000,dot);
#endif
	    for (right=0; right <= len; right++) {
		pat >>= 1;
		if (dot & pat) {	/* pat == 0 if right == len */
		    if (left < 0) left = right;
		} else {
		    if (left >= 0) {
#ifdef DEBUG
			HostFPrintF(HostFp," %d-%d",left,right-1);
#endif
			WinInvertLine(x+left,bottom,x+right-1,bottom);
		    }
		    left = -1;
		}
	    }
#ifdef DEBUG
	    HostFPrintF(HostFp,"\n");
#endif
	}
    }
}

static void invertItem(short item, short line,	/* [cell] */
		       CommentMarkType type,
		Boolean offs) {
    short x, y;
    x = item - OfsItem;
    y = line - OfsLine;
    if (0 <= x && 0 <= y && x < NItems && y < NLines) {
	x = TableX + HourWidth + ItemWidth * x + 2;
	if (offs) y = 1;
	else y = TableY + ItemHeight * y + 1;
	invertXY(x,y,type);
    }
}

static short commentY(short line) {
    return CommBottomY - CommentsHeight * (NShowComments - line);
}

static Boolean isLargeClockShown() {
    return LargeClockFlag && !StopClock && TransNLines <= 0;
}

static void drawComment(SByte *coms, short width, short x, short y) {
    /* never use CommentsTmp[] */
    short endX = x + width;
    short len;
    Boolean ok;
    short com;
    char *str;
    RectangleType r;
    if (*coms < 0) {
	com = NoComment;	/* without comments */
	if (CurrentTable->Comments) goto draw;
	else goto erase;
    }
    while ((com=*coms++) >= 0) {
    draw:
	str = CurrentTable->Comments[com];
	len = StrLen(str);
	width = endX - x;
	ok = true;
	FntCharsInWidth(str,&width,&len,&ok);
	if (*str && len <= 0) break;
	WinDrawChars(str,len,x,y);
	width = FntCharsWidth(str,len);
	x += width;
    }
 erase:
    r.topLeft.x = x;
    r.topLeft.y = y;
    r.extent.x = endX - x;
    r.extent.y = FntCharHeight();
    WinEraseRectangle(&r,0);
}

static void showComment(short n, char *time, SByte *coms, Boolean flag) {
    RectangleType r;
    short x, y, endX;
    WinHandle win = WinGetDrawWindow();	/* save current */
    endX = ScreenX;
    if (isLargeClockShown()
	&& NShowComments - LargeClockLines <= n) endX = LargeClockX;
    r.topLeft.x = TableX;
    r.topLeft.y = 0;
    r.extent.x = endX - r.topLeft.x;
    r.extent.y = CommentsHeight;
    x = r.topLeft.x;
    y = r.topLeft.y;
    WinSetDrawWindow(OffScreen);
    WinEraseRectangle(&r,0);
    if (time && CurrentTable->Comments) {
	WinDrawChars(time,StrLen(time),x,y);
	if (flag)
	    WinDrawLine(x+2,y+CommentsHeight-1,
			x+ItemWidth-SpaceWidth-4,y+CommentsHeight-1);
	x += FntCharsWidth(time,StrLen(time));
	drawComment(coms,endX-x,x,y);
    }
    x = TableX;
    y = commentY(n);
    WinCopyRectangle(OffScreen,win,&r,x,y,scrCopy);
    WinSetDrawWindow(win);	/* restore */
}

static Word getWord(Byte *p) {	/* return *p */
    Word ret;
    ret = *p++ << 8;	/* MSB Big endian */
    ret |= *p++;	/* LSB */
    return ret;
}

static Boolean getComments(TimeTableType *table,
			   short item, short line, SByte *comments) {
    /* never use CommentsTmp[] */
    LineType **Lines = table->Lines;
    short LinesLen = table->LinesLen;
    short ncom = 0;
    SByte *excom;
    short j, k, exlen;
    if (line < 0 || LinesLen <= line
	|| item < 0 || Lines[line]->length <= item
	|| Lines[line]->items[item].comment < 0) {	/* no comments */
	*comments = -1;
	return false;
    }
    comments[ncom++] = Lines[line]->items[item].comment;
    exlen = (short)getWord(&Lines[line]->excom_msb);
    if (exlen) {
	excom = (SByte*)&Lines[line]->items[(short)Lines[line]->length];
	for (j=0, k=0; j < exlen; j++) {
	    if (k >= item) {
		for (; j < exlen; j++) {
		    if (excom[j] < 0 || ncom >= ExCommentsMax - 1) break;
		    comments[ncom++] = excom[j];
		}
		break;
	    }
	    if (excom[j] == -1) k++;
	}
    }
    comments[ncom] = -1;
    return true;
}

static void showCommentLine(short n) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short i, hour, min;
    short item, line;
    char str[10];
    Boolean flag;
    item = SelItem;
    line = SelLine;
    i = 0;
    for (;;) {
	if (0 <= line && line < LinesLen) {
	    if (item >= Lines[line]->length) {
		item = 0;
		line++;
		continue;
	    }
	    if (!ShowCommentsFlag || UnderlineSpecialFlag
		|| Lines[line]->items[item].comment >= 0
		|| i == 0) {
		if (i >= n) {
		    hour = Lines[line]->hour;
		    min = Lines[line]->items[item].minute;
		    getComments(CurrentTable,item,line,CommentsTmp);
		    flag = false;
		    if (OmitHourFlag) {
			digit2str(min,str,true);
			str[2] = ' ';
			str[3] = '\0';
		    } else {
		/*	StrPrintF(str,"%02d:%02d ",hour,min);	*/
			digit2str(HOUR(hour),str,true);
			str[2] = ':';
			digit2str(min,&str[3],true);
			str[5] = ' ';
			str[6] = '\0';
			if (TwelveFlag && 12 <= hour && hour <= 23)
			    flag = true;
		    }
		    showComment(n,str,CommentsTmp,flag);
		    return;
		}
		i++;
	    }
	    item++;
	} else {
	    showComment(n,NULL,NULL,false);
	    return;
	}
    }
}

static void showComments(void) {
    short i;
    short nlines = NShowComments;
    for (i=0; i < nlines; i++) showCommentLine(i);
}

static Boolean commentMatch(SByte **pp, SByte *coms) {
    SByte *p, *q;
    Boolean ret = false;
    p = *pp;
    if (*p == -1) {
	ret = true;
	p++;
    } else if (coms) {
	while (*p >= 0) {
	    for (q=coms; *q >= 0; q++)
		if (*p == *q) ret = true;
	    p++;
	}
	if (*p == -1) p++;
    }
    *pp = p;
    return ret;
}

static short timeRequired(TimeTableType *table, short stn, SByte *coms) {
    SByte *p;
    short min = -1;
    short i;
    Boolean nocom;
    p = table->Arrives[stn];
    while (*p) p++;
    p++;
    p += 2;	/* trpos */
    while (*p >= -1) {	/* -1: end of comments, -2: end of line */
	nocom = (*p == -1);
	if (commentMatch(&p,coms)) {
	    i = (short)getWord((Byte*)p);
	    if (nocom && i == -2	/* '=' only */
		&& *coms >= 0) {	/* train w/ notes */
		;	/* '=' match to the train w/o notes */
	    } else {
		min = i;
	    }
	}
	p += sizeof(Word);
    }
    return min;
}

static void loadArrives(TimeTableType *table,
		 short column, short minute, SByte *coms) {
    /* never use CommentsTmp[] */
    short ArrivesLen = table->ArrivesLen;
    short min, i;
    for (i=0; i < ArrivesLen; i++) {
	if (minute < 0) ArriveTime[ArrivesLen*column+i] = -2;	/* no train */
	else {
	    min = timeRequired(table,i,coms);
	    if (min > 60) {	/* long trip */
		ArriveTime[ArrivesLen*column+i] = (minute + min) % (60*24);
	    } else if (min >= 0) {
		ArriveTime[ArrivesLen*column+i] = minute + min;
	    } else {
		ArriveTime[ArrivesLen*column+i] = -1;	/* pass */
	    }
	}
    }
}

static char *transFile(short n) {
    short len = StrLen(CurrentTable->Arrives[n]);
    Byte *p;
    short trpos;
    p = CurrentTable->Arrives[n] + len + 1;
    trpos = (short)getWord(p);
    if (trpos) {
	return p + trpos;
    } else {
	return NULL;
    }
}

static Boolean isTransfer(short n) {
    char *p = transFile(n);
    return p != NULL;
}

static void drawArrive(short n) {	/* n = -1: header */
    short ArrivesLen = CurrentTable->ArrivesLen;
    char **Arrives = CurrentTable->Arrives;
    RectangleType r;
    short endX, x, y, hwidth, bwidth, width, len;
    Boolean lowerPart;
    Boolean ok;
    short ohour, tim, otim, hour, min, col;
    char str[10];
    short nlines = NShowComments;
    WinHandle win = WinGetDrawWindow();	/* save current */
    if (ArriveTimeHeadType > HeadNone) nlines--;
    if (!ArriveBarFlag) endX = ScreenX;	/* no scroll bar */
    else endX = ArriveRightX;
    if (nlines - LargeClockLines <= n) {
	lowerPart = true;
	if (isLargeClockShown()) endX = LargeClockX;
    } else {
	lowerPart = false;
    }
    r.topLeft.x = TableX;
    r.topLeft.y = 0;
    r.extent.x = endX - r.topLeft.x;
    r.extent.y = CommentsHeight;
    x = r.topLeft.x;
    y = r.topLeft.y;
    WinSetDrawWindow(OffScreen);
    WinEraseRectangle(&r,0);
    if (OfsArrive + n >= ArrivesLen) goto copy;
    FntSetFont(boldFont);
    hwidth = FntCharsWidth("00:",3);
    bwidth = FntCharsWidth("00",2) + SpaceWidth;
    FntSetFont(stdFont);
    width = ItemWidth;	/* FntCharsWidth("00",2) + SpaceWidth */
    otim = -1;
    ohour = -1;
    for (col=0; col < ArrivesColumn; col++) {
	if (col > 0 && hwidth+width*(col+2) > r.extent.x) break;
	if (n == -1) {
	    tim = ArriveTimeHead[col];
	    if (tim < 0) break;
	} else {
	    if (ArriveTime[ArrivesLen*col+OfsArrive+n] < -1) break;
	    tim = ArriveTime[ArrivesLen*col+OfsArrive+n];
	}
	if (tim >= 0) {
	    hour = tim/60;
	    min = tim%60;
	    if (ohour < 0) {
		digit2str(HOUR(hour),str,true);
		str[2] = ':';
		str[3] = '\0';
		FntSetFont(boldFont);
		WinDrawChars(str,3,x,y);
		if (TwelveFlag && 12 <= hour && hour <= 23) {
		    WinDrawLine(x+2,y+CommentsHeight-1,
				x+bwidth-SpaceWidth-4,y+CommentsHeight-1);
		}
		FntSetFont(stdFont);
		ohour = hour;
	    }
	    if (col == 0) {
		digit2str(min,str,true);
		FntSetFont(boldFont);
		WinDrawChars(str,2,x+hwidth,y);
		FntSetFont(stdFont);
		if (n == -1 && ArriveTimeHeadMark[col] > UnMark)
		    invertXY(x+hwidth+2,y,ArriveTimeHeadMark[col]);
	    } else {
		digit2str(min,str,true);
		WinDrawChars(str,2,x+hwidth+bwidth+width*(col-1),y);
		if (n == -1 && ArriveTimeHeadMark[col] > UnMark)
		    invertXY(x+hwidth+bwidth+width*(col-1),y,
			     ArriveTimeHeadMark[col]);
	    }
	    if (tim < otim && otim - tim < 20 * 60) {	/* col > 0 */
		WinDrawLine(x+hwidth+bwidth+width*(col-1)+2,
			    y+CommentsHeight-1,
			    x+hwidth+bwidth+width*(col-1)+width-SpaceWidth-3,
			    y+CommentsHeight-1);
	    }
	    otim = tim;
	} else {
	    if (col == 0) {
		WinDrawChars("--",2,x+hwidth+bwidth-width,y);
	    } else {
		WinDrawChars("--",2,x+hwidth+bwidth+width*(col-1),y);
	    }
	}
	if (n == -1 && ArriveTimeHeadType == HeadNote) {
	    col = 1;
	    break;
	}
    }
    width = hwidth + bwidth + width * (col-1);
    x += width;
    width = r.extent.x - width;
    if (n >= 0) {
	len = StrLen(Arrives[OfsArrive+n]);
	ok = true;
	FntCharsInWidth(Arrives[OfsArrive+n],&width,&len,&ok);
	WinDrawChars(Arrives[OfsArrive+n],len,x,y);
	width = FntCharsWidth(Arrives[OfsArrive+n],len);
	if (isTransfer(OfsArrive+n)) {	/* transfer */
	    WinDrawLine(x-1,y+CommentsHeight-1,x+width,y+CommentsHeight-1);
	}
	if (width > StnExtent) StnExtent = width;
	if (lowerPart) StnXLower = x;
	else StnX = x;
    } else {
	if (ArriveTimeHeadType >= HeadNote && SelItem >= 0 && SelLine >= 0) {
	    getComments(CurrentTable,SelItem,SelLine,CommentsTmp);
	    drawComment(CommentsTmp,width,x,y);
	}
    }
 copy:
    x = TableX;
    if (ArriveTimeHeadType > HeadNone) y = commentY(n + 1);
    else y = commentY(n);
    WinCopyRectangle(OffScreen,win,&r,x,y,scrCopy);
    WinSetDrawWindow(win);	/* restore */
}

static void eraseArriveBarArea(void) {
    RectangleType r;
    r.topLeft.x = TableRightX + 1;
    r.topLeft.y = commentY(0) + 1;
    r.extent.x = ScreenX - r.topLeft.x;
    r.extent.y = ScreenY - r.topLeft.y;
    WinEraseRectangle(&r,0);
}

static void updateArriveBar(Boolean draw) {
    ScrollBarPtr bar;
    short nlines = NShowComments;
    if (ArriveTimeHeadType > HeadNone) nlines--;
    bar = FrmGetObjectPtr(MainFormPtr,FrmGetObjectIndex
			  (MainFormPtr,ArriveScrollBar));
    if (CurrentTable->ArrivesLen <= 1 /* nlines */
	|| isLargeClockShown()) {
	ArriveRightX = bar->bounds.topLeft.x - 1;
	ArriveBarFlag = false;
	if (bar) {
	    bar->attr.usable = false;
	}
	bar->bounds.extent.y = 0;
	return;
    }
    ArriveRightX = bar->bounds.topLeft.x - 1;
    if (!ArriveBarFlag && draw) {
	RectangleType r;
	r.topLeft.x = ArriveRightX;
	r.topLeft.y = commentY(0);
	r.extent.x = ScreenX - r.topLeft.x;
	r.extent.y = CommBottomY - r.topLeft.y;
	WinEraseRectangle(&r,0);
    }
    ArriveBarFlag = true;
    if (bar) {
	bar->attr.usable = true;
	if (draw) {
	    short old, new;
	    RectangleType r;
	    r.topLeft.x = TableRightX + 1;
	    r.extent.x = ScreenX - r.topLeft.x;
	    if (bar->bounds.extent.y) {
		new = commentY(0) + 1;
		old = bar->bounds.topLeft.y;
		if (old < new) {
		    r.topLeft.y = old;
		    r.extent.y = new + 5 - r.topLeft.y;
		    WinEraseRectangle(&r,0);
		} else if (old > new) {
		    r.topLeft.y = new;
		    r.extent.y = old + 5 - r.topLeft.y;
		    WinEraseRectangle(&r,0);
		}
		bar->bounds.topLeft.y = new;
		old += bar->bounds.extent.y;
		new = CommBottomY - 1;
		if (old < new) {
		    r.topLeft.y = old - 5;
		    r.extent.y = new + 2 - r.topLeft.y;
		    WinEraseRectangle(&r,0);
		} else if (old > new) {
		    r.topLeft.y = new - 5;
		    r.extent.y = old - r.topLeft.y;
		    WinEraseRectangle(&r,0);
		}
		bar->bounds.extent.y = new - bar->bounds.topLeft.y;
	    } else {
		bar->bounds.topLeft.y = commentY(0) + 1;
		bar->bounds.extent.y = CommBottomY - 1 - bar->bounds.topLeft.y;
	    }
	    if (ScreenY <= CommBottomY) bar->bounds.extent.y--;
	    SclSetScrollBar(bar,OfsArrive,
			    0,CurrentTable->ArrivesLen-1 /* nlines */,nlines);
	    SclDrawScrollBar(bar);
	} else {
	    SclSetScrollBar(bar,OfsArrive,
			    0,CurrentTable->ArrivesLen-1 /* nlines */,nlines);
	}
    }
}

static void scrollArrive(short lines) {
    short ArrivesLen = CurrentTable->ArrivesLen;
    RectangleType r, vacated;
    short dist, from, end, cfrom, cend, i;
    DirectionType dir;
    short nlines = NShowComments;
    short clines = LargeClockLines;
    if (ArriveTimeHeadType > HeadNone) nlines--;
    if (lines == 0 /* || ArrivesLen <= nlines */ ) return;
    if (lines > 0) {
	if (OfsArrive + 1 /* nlines */ + lines > ArrivesLen) {
	    lines = ArrivesLen - 1 /* nlines */ - OfsArrive;
	    if (lines == 0) return;
	}
	dir = up;
	dist = lines;
	end = nlines - 1;
	from = end - lines;
	cend = nlines - clines - 1;
	cfrom = cend - lines;
    } else {
	if (OfsArrive + lines < 0) {
	    lines = - OfsArrive;
	    if (lines == 0) return;
	}
	dir = down;
	dist = -lines;
	from = 0;
	end = from - lines - 1;
	cfrom = nlines - clines;
	cend = cfrom - lines - 1;
    }
    r.topLeft.x = TableX;
    r.topLeft.y = commentY(0);
    if (ArriveTimeHeadType > HeadNone) r.topLeft.y += CommentsHeight;
    if (isLargeClockShown()) {
	if (clines < nlines) {
	    if (dist < nlines - clines) {
		r.extent.x = ArriveRightX - r.topLeft.x;
		r.extent.y = (nlines - clines) * CommentsHeight;
		WinScrollRectangle(&r,dir,dist*CommentsHeight,&vacated);
	    } else {
		if (dir == up) cfrom = 0;
		else end = nlines - clines - 1;
	    }
	    r.topLeft.y = commentY(nlines - clines);
	    if (ArriveTimeHeadType > HeadNone) r.topLeft.y += CommentsHeight;
	} else {
	    cfrom = 0;
	    cend = -1;
	}
	if (dist < clines) {
	    r.extent.x = LargeClockX - r.topLeft.x;
	    r.extent.y = clines * CommentsHeight;
	    WinScrollRectangle(&r,dir,dist*CommentsHeight,&vacated);
	} else {
	    if (dir == up) from = nlines - clines;
	    else cend = nlines - 1;
	}
	OfsArrive += lines;
	for (i=from; i <= end; i++) drawArrive(i);
	for (i=cfrom; i <= cend; i++) drawArrive(i);
    } else {	/* no large clock */
	r.extent.x = ArriveRightX - r.topLeft.x;
	r.extent.y = CommentsHeight * nlines;
	if (dist < nlines) {
	    WinScrollRectangle(&r,dir,dist*CommentsHeight,&vacated);
	} else {
	    from = 0;
	    end = nlines - 1;
	}
	OfsArrive += lines;
	for (i=from; i <= end; i++) drawArrive(i);
	updateArriveBar(false);
    }
}

static void drawArrives(void) {
    short nlines = NShowComments;
    short i;
    if (ArriveTimeHeadType > HeadNone) {
	nlines--;
	drawArrive(-1);	/* draw header */
    }
    if (CurrentTable->ArrivesLen <= 1 /* nlines */)
	OfsArrive = 0;	/* no scroll */
    for (i=0; i < nlines; i++) {
	drawArrive(i);
    }
}

static void drawLowerSplit(Boolean draw) {
    /* lower split bar */
#if 0
    if (ScreenY <= CommBottomY) {
	if (draw) WinDrawLine(ScreenX-7,ScreenY-1,ScreenX-1,ScreenY-1);
	else WinEraseLine(ScreenX-7,ScreenY-1,ScreenX-1,ScreenY-1);
    } else {
	if (draw) WinDrawLine(TableX,CommBottomY,ScreenX-1,CommBottomY);
	else WinEraseLine(TableX,CommBottomY,ScreenX-1,CommBottomY);
    }
#endif
}

static Boolean nextTrain(short *itemP, short *lineP) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short item, line;
    short i = 1;
    if (*itemP < 0 || *lineP < 0) return false;
    item = *itemP;
    item++;
    for (line=*lineP; line < LinesLen; line++) {
	while (item < Lines[line]->length) {
	    if (Lines[line]->items[item].mark != CancelMark && --i <= 0) {
		*itemP = item;
		*lineP = line;
		return true;
	    } else {
		item++;
	    }
	}
	item = 0;
    }
    return false;
}

static void selectItem(short item, short line, Boolean draw) {	/* [cell] */
    short i;
    Boolean drawBar = false;
    if (item >= 0 && line >= 0) {
	invertItem(SelItem,SelLine,InvertMark,false);
	invertItem(item,line,InvertMark,false);
	SelItem = item;
	SelLine = line;
    } else {
	item = SelItem;
	line = SelLine;
	drawBar = true;
    }
    StnExtent = 0;
    if (draw) {
	if (NarrowMode >= 0) {
	    short nc, j;
	    getComments(CurrentTable,item,line,CommentsTmp);
	    if (NarrowList[0] >= 0 && NarrowList[1] == -1) {
		nc = NarrowList[0];
		for (i=0, j=0; CommentsTmp[i] >= 0; i++) {	/* remove nc */
		    if (nc == CommentsTmp[i]) continue;
		    CommentsTmp[j] = CommentsTmp[i];
		    j++;
		}
		CommentsTmp[j] = -1;
	    }
	    drawComment(CommentsTmp,ScreenX-NarrowEndX,NarrowEndX,TopY);
	}
	if (ShowArrivesFlag && CurrentTable->ArrivesLen > 0) {
	    LineType **Lines = CurrentTable->Lines;
	    for (i=0; i < ArrivesColumn; i++) {
		if (item < 0 || line < 0) { /* no train */
		    ArriveTimeHead[i] = -1;
		    ArriveTimeHeadMark[i] = UnMark;
		    loadArrives(CurrentTable,i,-1,NULL);
		} else {
		    ArriveTimeHead[i] = xy2train(item,line,true);
		    ArriveTimeHeadMark[i] = Lines[line]->items[item].mark;
		    getComments(CurrentTable,item,line,CommentsTmp);
		    loadArrives(CurrentTable,i,ArriveTimeHead[i],CommentsTmp);
		}
		if (item < 0 || line < 0 || !nextTrain(&item,&line)) {
		    item = line = -1;
		}
	    }
	    updateArriveBar(draw && drawBar);
	    drawArrives();
	    drawLowerSplit(true);
	} else {
	    showComments();
	}
    }
    SelectTrain = xy2train(SelItem,SelLine,true);
    if (SelectTrain < FirstTrain) SelectTrain += 24 * 60;
}

/* convert [pixel] to [cell] */
static Boolean findItem(short x, short y, short *itemp, short *linep) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    if (x < (TableX + HourWidth) || y < TableY) return false;
    x = (x - (TableX + HourWidth)) / ItemWidth;
    y = (y - TableY) / ItemHeight;
    if (y >= NLines || x >= NItems) return false;
    y += OfsLine;
    x += OfsItem;
    if (y >= LinesLen || x >= Lines[y]->length) return false;
    *itemp = x;
    *linep = y;
    return true;
}

static void drawTableLine(short i) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    RectangleType r;
    char str[3];
    short hour;
    short j;
    CommentMarkType mark;
    WinHandle win = WinGetDrawWindow();	/* save current */
    r.topLeft.x = TableX + 1;
    r.topLeft.y = 0;
    r.extent.x = HourWidth + ItemWidth * NItems - 1;
    r.extent.y = ItemHeight;
    WinSetDrawWindow(OffScreen);
    WinEraseRectangle(&r,0);
    WinDrawLine(TableX+ItemWidth,0,TableX+ItemWidth,ItemHeight);
    if (OfsLine+i < 0 || LinesLen <= OfsLine+i) goto copy;
    if (OfsLine+i == 0 || Lines[OfsLine+i-1]->hour != Lines[OfsLine+i]->hour) {
/*	StrPrintF(str,"%2d",Lines[OfsLine+i]->hour);	*/
	hour = Lines[OfsLine+i]->hour;
	digit2str(HOUR(hour),str,false);
	WinDrawChars(str,2,TableX+2,1);
	if (TwelveFlag && 12 <= hour && hour <= 23) {
	    WinDrawLine(TableX+4,ItemHeight-1,
			TableX+ItemWidth-5,ItemHeight-1);
	}
	WinDrawLine(TableX,0,TableRightX,0);
    } else if (i == 0) {
	WinDrawLine(TableX,0,TableRightX,0);
    }
    for (j=0; j < NItems; j++) {
	if (j >= Lines[OfsLine+i]->length) break;
/*	StrPrintF(str,"%02d",
		  Lines[OfsLine+i]->items[OfsItem+j].minute);	*/
	digit2str(Lines[OfsLine+i]->items[OfsItem+j].minute,str,true);
	WinDrawChars(str,2,TableX+HourWidth+ItemWidth*j+2,1);
	if ((ShowCommentsFlag || UnderlineSpecialFlag)
	    && (mark=Lines[OfsLine+i]->items[OfsItem+j].mark) > UnMark) {
	    invertItem(OfsItem+j,OfsLine+i,mark,true);
	}
    }
    if (OfsLine+i == SelLine) invertItem(SelItem,SelLine,InvertMark,true);
 copy:
    WinCopyRectangle(OffScreen,win,&r,TableX+1,TableY+ItemHeight*i,scrCopy);
    WinSetDrawWindow(win);	/* restore */
}

static void updateHistoryButton(void) {
    ControlPtr control;
    Word index;
    short cur;
    cur = HistoryCur - 1;
    if (cur < 0) cur += HISTORYMAX;
    index = FrmGetObjectIndex(MainFormPtr,MainBackward);
    control = FrmGetObjectPtr(MainFormPtr,index);
    FrmGetObjectBounds(MainFormPtr,index,&BackwardButtonRect);
    if (cur != HistoryBot) {
	CtlShowControl(control);
    } else {
	CtlHideControl(control);
	BackwardButtonRect.extent.x = 0;
	BackwardButtonRect.extent.y = 0;
    }
    index = FrmGetObjectIndex(MainFormPtr,MainForward);
    control = FrmGetObjectPtr(MainFormPtr,index);
    FrmGetObjectBounds(MainFormPtr,index,&ForwardButtonRect);
    if (HistoryCur != HistoryTop) {
	CtlShowControl(control);
    } else {
	CtlHideControl(control);
	ForwardButtonRect.extent.x = 0;
	ForwardButtonRect.extent.y = 0;
    }
}

static void updateTableBar(Boolean draw) {
    short LinesLen = CurrentTable->LinesLen;
    ScrollBarPtr bar;
    bar = FrmGetObjectPtr(MainFormPtr,FrmGetObjectIndex
			  (MainFormPtr,MainScrollBar));
    if (LinesLen <= NLines) {	/* no scroll bar */
	RectangleType r;
	r.topLeft.x = TableRightX + 1;
	r.topLeft.y = TableY;
	r.extent.x = ScreenX - r.topLeft.x;
	r.extent.y = ItemHeight * NLines;
	WinEraseRectangle(&r,0);	/* erase scroll bar area */
	if (bar) {
	    bar->attr.usable = false;
	}
	return;
    }
    if (bar) {
	bar->attr.usable = true;
	if (draw) {
	    short old, new;
	    RectangleType r;
	    r.topLeft.x = TableRightX + 1;
	    r.extent.x = ScreenX - r.topLeft.x;
	    old = bar->bounds.topLeft.y;
	    new = TableY + 1;
	    if (old < new) {
		r.topLeft.y = old;
		r.extent.y = new + 5 - r.topLeft.y;
		WinEraseRectangle(&r,0);
	    } else if (old > new) {
		r.topLeft.y = new;
		r.extent.y = old + 5 - r.topLeft.y;
		WinEraseRectangle(&r,0);
	    }
	    bar->bounds.topLeft.y = new;
	    old += bar->bounds.extent.y;
	    new += ItemHeight * NLines - 2;
	    if (old < new) {
		r.topLeft.y = old - 5;
		r.extent.y = new + 2 - r.topLeft.y;
		WinEraseRectangle(&r,0);
	    } else if (old > new) {
		r.topLeft.y = new - 5;
/*		if (ArriveBarFlag) r.extent.y = old - r.topLeft.y;
		else*/ r.extent.y = new - r.topLeft.y;
		WinEraseRectangle(&r,0);
	    }
	    bar->bounds.extent.y = new - bar->bounds.topLeft.y;
	    SclSetScrollBar(bar,OfsLine,0,LinesLen-NLines,NLines);
	    SclDrawScrollBar(bar);
	} else {
	    SclSetScrollBar(bar,OfsLine,0,LinesLen-NLines,NLines);
	}
    }
}

static void scrollTable(short lines) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    RectangleType r, vacated;
    short dist, from, end, i;
    DirectionType dir;
    if (lines == 0 || LinesLen <= NLines) return;
    if (lines > 0) {
	if (OfsLine + NLines + lines > LinesLen) {
	    lines = LinesLen - NLines - OfsLine;
	    if (lines == 0) return;
	}
	dir = up;
	dist = lines;
	from = NLines - 1 - lines;
	end = NLines - 1;
    } else {
	if (OfsLine + lines < 0) {
	    lines = - OfsLine;
	    if (lines == 0) return;
	}
	dir = down;
	dist = -lines;
	from = 0;
	end = -lines - 1;
    }
    r.topLeft.x = TableX + 1;
    r.topLeft.y = TableY;
    r.extent.x = HourWidth + ItemWidth * NItems - 1;
    r.extent.y = ItemHeight * NLines;
    OfsLine += lines;
    if (dist < NLines) {
	WinScrollRectangle(&r,dir,dist*ItemHeight,&vacated);
	if (dir == down) {
	    if (Lines[OfsLine+dist-1]->hour == Lines[OfsLine+dist]->hour) {
		WinEraseLine(TableX+1,TableY+ItemHeight*dist,
			     TableX+ItemWidth-1,TableY+ItemHeight*dist);
		WinEraseLine(TableX+ItemWidth+1,TableY+ItemHeight*dist,
			     TableRightX-1,TableY+ItemHeight*dist);
	    }
	} else {
	    if (OfsLine > 0
		&& Lines[OfsLine]->hour == Lines[OfsLine-1]->hour)
		WinDrawLine(TableX+1,TableY,TableRightX-1,TableY);
	}
    } else {
	from = 0;
	end = NLines - 1;
    }
    for (i=from; i <= end; i++) drawTableLine(i);
    updateTableBar(false);
}

static void scrollComments(short lines) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short tItem, tLine;
    short line;
    tItem = SelItem;
    tLine = SelLine;
    if (tItem < 0 || tLine < 0) return;
    if (lines > 0) {
	if (lines < Lines[tLine]->length - tItem) {
	    tItem += lines;
	} else {
	    lines -= Lines[tLine]->length - tItem;
	    tItem = Lines[tLine]->length - 1;
	    for (line = tLine+1; line < LinesLen; line++) {
		if (lines < Lines[line]->length) {
		    tItem = lines;
		    tLine = line;
		    break;
		} else if (Lines[line]->length > 0) {
		    lines -= Lines[line]->length;
		    tItem = Lines[line]->length - 1;
		    tLine = line;
		}
	    }
	}
	if (OfsLine+NLines-1 <= tLine)
	    scrollTable(tLine - OfsLine - NLines/4);
    } else if (lines < 0) {
	if (-lines <= tItem) {
	    tItem += lines;
	} else {
	    lines += tItem;
	    tItem = 0;
	    for (line = tLine-1; line >= 0; line--) {
		if (-lines <= Lines[line]->length) {
		    tItem = Lines[line]->length + lines;
		    tLine = line;
		    break;
		} else if (Lines[line]->length > 0) {
		    lines += Lines[line]->length;
		    tItem = 0;
		    tLine = line;
		}
	    }
	}
	if (tLine < OfsLine)
	    scrollTable(tLine - OfsLine - NLines*2/3);
    } else {
	return;
    }
    if (tItem != SelItem || tLine != SelLine) {
	ManualSelectFlag = true;	/* manually selected */
	selectItem(tItem,tLine,true);
    }
}

static void focusItem(short line, Boolean draw) {
    if (line < OfsLine || OfsLine+NLines-1 <= line) {
	if (draw) {
	    scrollTable(line - OfsLine - NLines/3);
	} else {
	    OfsLine = line - NLines/3;
	    if (OfsLine < 0) OfsLine = 0;
	    else if (OfsLine + NLines > CurrentTable->LinesLen) {
		OfsLine = CurrentTable->LinesLen - NLines;
		if (OfsLine < 0) OfsLine = 0;
	    }
	}
    }
}

static void setNextTrain(short *itemP, short *lineP) {
    DateTimeType dateTime;
    TimSecondsToDateTime((StopClock ? StopClock: TimGetSeconds()),&dateTime);
    NextTrain = minute2nextTrain(dateTime.hour * 60 + dateTime.minute,
				 itemP, lineP);
}

static void selectCurrent(Boolean notes, Boolean draw) {
    short item, line;
    setNextTrain(&item,&line);
    focusItem(line,draw);
    SelectTrain = NextTrain;
    if (draw) {
	selectItem(item,line,notes);
    } else {
	SelItem = item;
	SelLine = line;
    }
    ManualSelectFlag = false;	/* automatically selected */
}

static void drawBitmap(short num, short x, short y) {
    BitmapPtr p;
    p = MemHandleLock(NumBitmap[num]);
    WinDrawBitmap(p,x,y);
    MemHandleUnlock(NumBitmap[num]);
}

static Boolean drawLargeClock(short min, short sec) {
    RectangleType r;
    Boolean minus;
    Boolean colon = false;
    if (min - 24 * 60 > LargeClockMin
	|| (min - 24 * 60 == LargeClockMin && sec > 0)) min -= 24 * 60;
    if (min < 0) {
	minus = true;
	min = -min;
	if (sec > 0) {
	    sec = 60 - sec;
	    min--;
	}
	if (min >= 10) {	/* >= 10min */
	    sec = min % 60;
	    min = min / 60;
	    colon = true;
	}
    } else {
	minus = false;
	if (min >= 60) {	/* >= 1hour */
	    sec = min % 60;
	    min = min / 60;
	    colon = true;
	}
    }
    r.topLeft.x = LargeClockX;
    r.topLeft.y = ScreenY - CommentsHeight * LargeClockLines;
    r.extent.x = ScreenX - r.topLeft.x;
    r.extent.y = LargeClockY - r.topLeft.y;
    WinEraseRectangle(&r,0);
    if (minus) drawBitmap(11,LargeClockX,LargeClockY);
    else drawBitmap(min/10,LargeClockX,LargeClockY);
    drawBitmap(min%10,LargeClockX+NumBitmapX,LargeClockY);
    drawBitmap(10,LargeClockX+NumBitmapX*2,LargeClockY);
    drawBitmap(sec/10,LargeClockX+NumBitmapX*2+ColonBitmapX,LargeClockY);
    drawBitmap(sec%10,LargeClockX+NumBitmapX*3+ColonBitmapX,LargeClockY);
    return colon;
}

static void eraseLargeClock(Boolean redraw) {
    RectangleType r;
    r.topLeft.x = TableRightX;
    r.topLeft.y = LargeClockY;
    r.extent.x = ScreenX - r.topLeft.x;
    r.extent.y = ScreenY - r.topLeft.y;
    WinEraseRectangle(&r,0);
    if (redraw) DrawNotesFlag = true;	/* redraw comments area */
}

static void drawAlarm(void) {
    BitmapPtr p;
    if (!AlarmBitmap) return;
    if (AlarmMinute >= 0) {
	p = MemHandleLock(AlarmBitmap);
	WinDrawBitmap(p,AlarmRect.topLeft.x,AlarmRect.topLeft.y);
	MemHandleUnlock(AlarmBitmap);
    } else {
	WinEraseRectangle(&AlarmRect,0);
    }
}

static void drawAlarmTime(void) {
    char str[10];
    CustomPatternType savePattern;
    if (AlarmMinute < 0) return;
    WinGetPattern(savePattern);
    WinSetPattern(BlackPattern);
    digit2str(AlarmMinute/60,str,true);
    str[2] = ':';
    digit2str(AlarmMinute%60,&str[3],true);
    FntSetFont(boldFont);
    WinFillRectangle(&NormalClockRect,0);
    WinInvertChars(str,StrLen(str),
		   NormalClockRect.topLeft.x,NormalClockRect.topLeft.y);
    WinSetPattern(savePattern);
    FntSetFont(stdFont);
}

static void popupAlarmDialog(void) {
    if (SelectTrain >= 0) DepTime = SelectTrain;
    else if (NextTrain >= 0) DepTime = NextTrain;
    else return;
    FrmPopupForm(AlarmDialog);
}

void drawTime(Boolean draw) {
    static short prevSelectTrain;
    static Boolean prevLargeClockFlag;
    static Boolean prevScreenFlag;
    static ULong prevTick;
    static Boolean smallColon;
    static Boolean largeColon;
    static short prevAlarmMinute;
    ULong time;
    ULong tick;
    WinHandle win, swin;
    RectangleType r;
    short current, min, sec;
    char str[10];
    DateTimeType dateTime;
    Boolean screenFlag = !menuAppear();
    if (screenFlag && AlarmMinute != prevAlarmMinute && AlarmTapCount <= 0) {
	drawAlarm();
	prevAlarmMinute = AlarmMinute;
    }
    time = TimGetSeconds();
    tick = TimGetTicks();
    if (StopClock) {
	if (time < StopClock) {
	    time = StopClock;
	} else {
	    StopClock = 0;
	    DrawNotesFlag = true;	/* redraw comments area */
	}
    }
    if (screenFlag && !AlarmDialogFlag && DrawNotesFlag) {
	selectItem(-1,-1,true);
	DrawNotesFlag = false;
    }
    if (prevTick && tick - prevTick > TicksPerSeconds/3) {
	prevTick = 0;
	if (smallColon && screenFlag && AlarmTapCount == 0) {
	    r.topLeft.x = TimeLeftColonX;
	    r.topLeft.y = TimeY;
	    r.extent.x = BoldColonWidth;
	    r.extent.y = TimeHeight;
	    WinEraseRectangle(&r,0);
	}
	if (largeColon && screenFlag && isLargeClockShown()) {
	    r.topLeft.x = LargeClockX+NumBitmapX*2;
	    r.topLeft.y = LargeClockY;
	    r.extent.x = ColonBitmapX;
	    r.extent.y = ScreenY - LargeClockY;
	    WinEraseRectangle(&r,0);
	}
    }
    if (!draw && time == PrevTime
	&& prevSelectTrain == SelectTrain
	&& prevLargeClockFlag == LargeClockFlag
	&& prevScreenFlag == screenFlag) return;
    if (time - PrevTime > 2) {	/* powered off ? */
	LastSec = time;
    }
    PrevTime = time;
    prevSelectTrain = SelectTrain;
    prevLargeClockFlag = LargeClockFlag;
    prevScreenFlag = screenFlag;
    prevTick = tick;
    smallColon = largeColon = false;
    TimSecondsToDateTime(time,&dateTime);
    min = dateTime.hour * 60 + dateTime.minute;
    if (AlarmMinute >= 0) {
	AlarmMinuteSave = AlarmMinute;
	min -= AlarmMinute;
	if (min < 0) min += 24 * 60;
	if (dateTime.second % (min+1) == 0) AlarmMinute = getAlarm();
	if (screenFlag
	    && AlarmMinute != prevAlarmMinute && AlarmTapCount <= 0) {
	    drawAlarm();
	    prevAlarmMinute = AlarmMinute;
	}
    } else if (AlarmMinuteSave >= 0) {
	min -= AlarmMinuteSave;
	if (min < 0) min += 24 * 60;
	if (min <= (24 * 60 - AlarmMinuteMax)) AlarmMinuteSave = -1;
    }
    win = WinGetDrawWindow();	/* save current */
    swin = WinGetDisplayWindow();
    WinSetDrawWindow(swin);
/*  StrPrintF(str,"%02d:%02d:%02d",
	      dateTime.hour,dateTime.minute,dateTime.second);	*/
    digit2str(HOUR(dateTime.hour), str, true);
    str[2] = ':';
    digit2str(dateTime.minute,&str[3],true);
    str[5] = ':';
    digit2str(dateTime.second,&str[6],true);
    r.topLeft.x = TimeX;
    r.topLeft.y = TimeY;
    r.extent.x = TimeWidth;
    r.extent.y = TimeHeight;
    if (ClockInvertedFlag) {
	CustomPatternType savePattern;
	WinGetPattern(savePattern);
	WinSetPattern(BlackPattern);
	WinFillRectangle(&r,0);
	WinSetPattern(savePattern);
	WinInvertChars(str,StrLen(str),TimeX,TimeY);
    } else {
	WinEraseRectangle(&r,0);
	WinDrawChars(str,StrLen(str),TimeX,TimeY);
    }
    current = xy2train(dateTime.minute,dateTime.hour,false);
#ifdef DEBUG
    HostFPrintF(HostFp,"current: %d, NextTrain: %d, SelectTrain: %d\n",
		current,NextTrain,SelectTrain);
#endif
    if (screenFlag
	&& (NextTrain <= current
	    || current == LastTrain
	    || (current <= FirstTrain && FirstTrain < NextTrain))) {
	if (!SelectCurrentFlag) {
	    if (ManualSelectFlag || AlarmDialogFlag) {
		setNextTrain(NULL,NULL);
	    } else {
		SelectCurrentFlag = true;
		selectCurrent(false,true);	/* don't draw notes */
		DrawNotesFlag = true;
	    }
	}
    } else SelectCurrentFlag = false;
    min = NextTrain - current;
    if (min < 0) min += 24 * 60;
    else if (min > 24*60) min -= 24 * 60;
    if (dateTime.second > 0) {
	min--;
	sec = 60 - dateTime.second;
    } else sec = 0;
    if (screenFlag && AlarmTapCount > 0) {
	AlarmTapCount--;
	if (AlarmTapCount == 0) {
	    drawAlarm();
	    WinEraseRectangle(&NormalClockRect,0);
	}
    }
    if (AlarmTapCount == 0) {
	if (min < 60) {		/* < 1hour */
	    /*	    	StrPrintF(str,"%02d:%02d",min,sec);	*/
	    digit2str(min,str,true);
	    str[2] = ':';
	    digit2str(sec,&str[3],true);
	} else {		/* > 1hour */
	    digit2str(min/60,str,true);
	    str[2] = ':';
	    digit2str(min%60,&str[3],true);
	    smallColon = true;
	}
	FntSetFont(boldFont);
	WinDrawChars(str,StrLen(str),TimeLeftX,TimeY);
	FntSetFont(stdFont);
    }
    min = SelectTrain - current;
    if (min < 0) min += 24 * 60;
    else if (min > 24*60) min -= 24 * 60;
    if (dateTime.second > 0) min--;
    if (screenFlag && isLargeClockShown()) {
	largeColon = drawLargeClock(min,sec);
    }
    WinSetDrawWindow(win);	/* restore */
}

static void drawTableTime(void) {
    short i;
    for (i=0; i < NLines; i++) drawTableLine(i);
    WinDrawLine(TableX,TableY+ItemHeight*i,
		TableRightX,TableY+ItemHeight*i);
}

static void setupNarrowPopup(FormPtr frm) {
    ListPtr list;
    ControlPtr control;
    Word lindex, cindex;
    short width, height;
    short i;
    cindex = FrmGetObjectIndex(frm,MainPopupNarrow);
    control = FrmGetObjectPtr(frm,cindex);
    if (!control) return;
    lindex = FrmGetObjectIndex(frm,MainPopupListNarrow);
    list = FrmGetObjectPtr(frm,lindex);
    if (!list) return;
    if (NarrowMode >= 0) {
	if (!NarrowOrgItemsText) {
	    NarrowOrgItemsText = list->itemsText;	/* save original */
	    NarrowOrgNumItems = list->numItems;
	    NarrowOrgItemWidth = list->bounds.extent.x;
	}
	list->itemsText = CurrentTable->Narrows;
	list->numItems = CurrentTable->NarrowsLen;
	list->itemsText[0] = NarrowOrgItemsText[0];
	list->itemsText[1] = NarrowOrgItemsText[1];
	list->bounds.extent.x = 0;
	for (i=0; i < CurrentTable->NarrowsLen; i++) {
	    width = FntCharsWidth(list->itemsText[i],
				  StrLen(list->itemsText[i]));
	    if (list->bounds.extent.x < width) list->bounds.extent.x = width;
	}
	if (list->bounds.extent.x > NarrowOrgItemWidth)
	    list->bounds.extent.x = NarrowOrgItemWidth;
	height = FntCharHeight();
	list->bounds.extent.y = height * list->numItems;
	height *= NarrowOrgNumItems;
	if (list->bounds.extent.y > height)
	    list->bounds.extent.y = height;
	control->bounds.extent.x
	    = FntCharsWidth(list->itemsText[NarrowMode],
			    StrLen(list->itemsText[NarrowMode]));
	CtlSetLabel(control,list->itemsText[NarrowMode]);
	CtlShowControl(control);
	FrmGetObjectBounds(frm,cindex,&NarrowPopupRect);
	FntSetFont(boldFont);
	WinDrawChars(": ",2,
		     NarrowPopupRect.topLeft.x + NarrowPopupRect.extent.x,
		     NarrowPopupRect.topLeft.y);
	NarrowEndX = NarrowPopupRect.topLeft.x + NarrowPopupRect.extent.x
	    + FntCharsWidth(": ",2);
	FntSetFont(stdFont);
    } else {
	if (NarrowOrgItemsText) {
	    list->itemsText = NarrowOrgItemsText;
	    list->numItems = NarrowOrgNumItems;
	    list->bounds.extent.x = NarrowOrgItemWidth;
	    NarrowOrgItemsText = NULL;
	}
	CtlHideControl(control);
    }
}

static void drawTable(void) {
    LineType **Lines = CurrentTable->Lines;
    short LinesLen = CurrentTable->LinesLen;
    short width, len;
    short item, line;
    Boolean ok;
    RectangleType r;
#ifdef PROFILE
    HostFPrintF(HostFp,"drawTable(void) %lu\n",TimGetTicks());
#endif
    width = ScreenX - TableX;
    r.topLeft.x = TableX;
    r.topLeft.y = TopY-ItemHeight;
    r.extent.x = width;
    r.extent.y = ItemHeight;
    if (NarrowMode >= 0) {
	TableY = TopY + ItemHeight;
    } else {
	TableY = TopY;
    }
    r.extent.y = TableY - r.topLeft.y;
    WinEraseRectangle(&r,0);	/* erase Title area */
    len = StrLen(Title);
    ok = true;
    FntCharsInWidth(Title,&width,&len,&ok);
    WinDrawChars(Title,len,r.topLeft.x,r.topLeft.y);
    setupNarrowPopup(MainFormPtr);
    WinDrawLine(TableX,TableY,TableX,TableBottomY);
    WinDrawLine(TableRightX,TableY,
		TableRightX,TableBottomY);
    r.topLeft.x = TableX;
    r.topLeft.y = TableBottomY + 1;
    r.extent.x = ScreenX - r.topLeft.x;
    r.extent.y = commentY(0) - r.topLeft.y;
    WinEraseRectangle(&r,0);	/* beneath table */
    OfsLine = 0;
    OfsItem = 0;
    if (0 <= SelItem && 0 <= SelLine) {
	if (LinesLen <= SelLine
	    || Lines[SelLine]->length <= SelItem) {
	    unselectItem();
	}
    } else {
	unselectItem();
    }
    item = SelItem;
    line = SelLine;
    selectCurrent(false,false);	/* don't draw */
    if (0 <= item && 0 <= line) {
	ManualSelectFlag = true;	/* manually selected */
	selectItem(item,line,false);
	focusItem(SelLine,false);
    }
    drawTableTime();
    drawTime(false);
    DrawNotesFlag = true;	/* redraw comments area */
    drawTime(true);
    updateTableBar(true);
    /* upper split bar */
    WinDrawLine(ScreenX-7,TableBottomY,ScreenX-1,TableBottomY);
    if (ShowArrivesFlag && CurrentTable->ArrivesLen > 0) updateArriveBar(true);
    drawAlarm();
}

static Boolean handlePenTable(EventPtr e) {
    static short px, py;
    short x, y;
    if (findItem(e->screenX,e->screenY,&x,&y)) {
	if (e->eType == penDownEvent
	    || !(x == px && y == py)) {
	    px = x;
	    py = y;
	    ManualSelectFlag = true;	/* manually selected */
	    selectItem(x,y,true);
	}
    }
    return true;
}

static void doTransfer(short trn) {
    short ArrivesLen = CurrentTable->ArrivesLen;
    long recordNum;
    char *p;
    short pos, ofs;
    ULong tim;
    DateTimeType dateTime;
    short min;
    p = transFile(trn);
    if (p) {
	TimeTableType *saveTable = CurrentTable;
	tim = TimGetSeconds();
	TimSecondsToDateTime(tim,&dateTime);
	tim -= dateTime.second + 1;
	min = dateTime.hour * 60 + dateTime.minute;
	while (trn < ArrivesLen * ArrivesColumnMax
	       && ArriveTime[trn] >= -1) {
	    if (ArriveTime[trn] >= 0) {
		min = ArriveTime[trn] % (60*24) - min;
		if (min < 0) min += (60*24);
		tim += (ULong)min * 60;
		break;
	    }
	    trn += ArrivesLen;
	}
	recordNum = searchTransfer(p,&ofs);
	putLRU();
	saveHisAttr(HistoryCur);
	CurrentTable = NULL;
	if (recordNum >= 0 && loadTrainTimeDB(recordNum)) {
	    ArrivesLen = CurrentTable->ArrivesLen;
	    pos = HistoryCur;
	    do {
		pos = pushHistory(recordNum,pos);
		saveHisAttr(pos);
		HisAttr[pos].StopClock = tim + (ULong)ofs * 60L;
		HisAttr[pos].ManualSelectFlag = false;
		recordNum = searchTransfer(NULL,&ofs);
	    } while (recordNum >= 0);
	    forwardHistory();
	    updateHistoryButton();
	    eraseLargeClock(false);
	    unselectItem();
	    drawTable();
	    if (SelItem >= 0 && SelLine >= 0) ManualSelectFlag = true;
	    disposeTimeTable(saveTable);
	    saveTable = NULL;
	} else {
	    CurrentTable = saveTable;
	}
    }
}

static void do1stTransfer(void) {
    short trn;
    for (trn=OfsArrive; trn < CurrentTable->ArrivesLen; trn++) {
	if (isTransfer(trn)) {
	    doTransfer(trn);
	    return;
	}
    }
    for (trn=OfsArrive-1; trn >= 0; trn--) {
	if (isTransfer(trn)) {
	    doTransfer(trn);
	    return;
	}
    }
}

static void restartClock(void) {
    short item, line;
    StopClock = 0;
    setNextTrain(&item,&line);
    if (isLargeClockShown())
	DrawNotesFlag = true;	/* redraw comments area */
    drawTime(true);
}

static Boolean handlePenComment(EventPtr e) {
    short ArrivesLen = CurrentTable->ArrivesLen;
    static short pstn;
    static Boolean on;
    static short px, py;
    static short pdx, pdy;
    static Boolean moveFlag;
    static short stnx;
    short stn, trn, dx, dy;
    RectangleType r;
    if (e->eType == penDownEvent) {
	if (e->screenY < ScreenY-CommentsHeight*LargeClockLines) stnx = StnX;
	else stnx = StnXLower;
    }
    if (stnx <= e->screenX && e->screenX < stnx + StnExtent) {
	stn = (e->screenY-commentY(0)) / CommentsHeight;
    } else {
	stn = -1;
    }
    r.topLeft.x = stnx;
    r.extent.x = StnExtent;
    r.extent.y = CommentsHeight;
    if (e->eType == penDownEvent) {
	px = e->screenX;
	py = e->screenY;
	pdx = 0;
	pdy = 0;
	moveFlag = false;
	on = false;
	pstn = stn;
	if (stn >= 0) {
	    trn = stn + OfsArrive;
	    if (ArriveTimeHeadType > HeadNone) trn--;
	    if (trn >= OfsArrive && trn < ArrivesLen && isTransfer(trn)) {
		r.topLeft.y = commentY(stn);
		WinInvertRectangle(&r,0);
		on = true;
	    } else {
		pstn = -1;
	    }
	}
    } else if (e->eType == penMoveEvent) {
	if (pstn >= 0) {
	    if ((on && stn != pstn)
		|| (!on && stn == pstn)) {
		r.topLeft.y = commentY(pstn);
		WinInvertRectangle(&r,0);
		on = !on;
	    }
	} else {
	    dx = (e->screenX - px) / ItemWidth;
	    dy = (e->screenY - py) / CommentsHeight;
	    if (dx != pdx && ShowArrivesFlag && ArrivesLen > 0
		&& ArrivesColumn > 1) {
		moveFlag = true;
		scrollComments(pdx - dx);
		pdx = dx;
	    }
	    if (dy != pdy) {
		moveFlag = true;
		if (ShowArrivesFlag && ArrivesLen > 0) scrollArrive(pdy - dy);
		else scrollComments(pdy - dy);
		pdy = dy;
	    }
	}
    } else if (e->eType == penUpEvent) {
	if (pstn >= 0) {
	    if (on) {
		r.topLeft.y = commentY(pstn);
		WinInvertRectangle(&r,0);
	    }
	    if (stn == pstn) {
		trn = stn + OfsArrive;
		if (ArriveTimeHeadType > HeadNone) trn--;
		doTransfer(trn);	/* transfer */
	    }
	} else if (LargeClockY <= e->screenY
		   && LargeClockX+NumBitmapX <= e->screenX
		   && !moveFlag && pstn < 0 && LargeClockFreq > Never
		   && TransNLines <= 0) {
	    if (StopClock) {
		restartClock();
		ManualSelectFlag = true;
	    }
	    LargeClockFlag = true;
	    DrawNotesFlag = true;	/* redraw comments area */
	    drawTime(true);
	} else if (!moveFlag && stn < 0) {
	    if (UnderlineSpecialFlag) {
		if (ArrivesLen > 0) {
		    ShowArrivesFlag = !ShowArrivesFlag;
		    if (ShowArrivesFlag) eraseArriveBarArea();

		}
	    } else if (ArrivesLen == 0) {
		ShowCommentsFlag = !ShowCommentsFlag;
	    } else {
		if (ShowCommentsFlag) {	/* only comments -> arrives */
		    ShowCommentsFlag = false;
		    ShowArrivesFlag = true;
		    eraseArriveBarArea();
		    drawTableTime();
		} else if (ShowArrivesFlag) {	/* arrives -> normal */
		    ShowArrivesFlag = false;
		} else {	/* normal -> only comments */
		    ShowCommentsFlag = true;
		    drawTableTime();
		}
	    }
	    DrawNotesFlag = true;	/* redraw comments area */
	}
    }
    return true;
}

static Boolean handlePenClock(EventPtr e) {
    if (e->eType == penUpEvent) {
	LargeClockFlag = false;
	eraseLargeClock(true);
    }
    return true;
}

static Boolean handlePenElse(EventPtr e) {
    static Boolean clock;
    Boolean in;
    RectangleType r;
    r.topLeft.x = TimeX;
    r.topLeft.y = TimeY;
    r.extent.x = TimeWidth;
    r.extent.y = TimeHeight;
    in = (r.topLeft.x <= e->screenX && e->screenY < r.topLeft.y + r.extent.y);
    if (e->eType == penDownEvent) {
	if (in) {	/* clock */
	    WinInvertRectangle(&r,0);
	    clock = true;
	    ClockInvertedFlag = true;
	} else {
	    clock = false;
	}
    } else if (e->eType == penMoveEvent) {
	if (clock) {
	    if ((in && !ClockInvertedFlag)
		|| (!in && ClockInvertedFlag)) {
		WinInvertRectangle(&r,0);
		ClockInvertedFlag = !ClockInvertedFlag;
	    }
	}
    } else if (e->eType == penUpEvent) {
	if (clock) {
	    if (ClockInvertedFlag) WinInvertRectangle(&r,0);
	    ClockInvertedFlag = false;
	    if (in) {
		if (StopClock) {
		    restartClock();
		    ManualSelectFlag = true;
		} else {
		    StopClock = TimGetSeconds();
		    switch (StopClockInterval) {
		    case 0:  StopClock += 60;    break;  /*  1 min */
		    case 1:  StopClock += 3*60;  break;  /*  3 min */
		    case 2:  StopClock += 5*60;  break;  /*  5 min */
		    case 3:  StopClock += 10*60; break;  /* 10 min */
		    case 4:  StopClock += 15*60; break;  /* 15 min */
		    case 5:  StopClock += 30*60; break;  /* 30 min */
		    case 6:  StopClock += 60*60; break;  /*  1 hour */
		    default: StopClock += 3*60;
		    }
		    eraseLargeClock(true);
		    drawTime(true);
		}
	    }
	    clock = false;
	} else {
	    SelectTrain = -1;
	    selectCurrent(true,true);
	}
    }
    return true;
}

static Boolean handlePenSplit(EventPtr e, short part) {
    static short py;
    RectangleType r;
    short ey = e->screenY;
    short height = 3;
    short y, minY, maxY;
    r.topLeft.x = 0;
    r.extent.x = ScreenX;
    r.extent.y = height;
    switch (part) {
    case 1:	/* upper split bar */
	minY = TableY + ItemHeight * NLinesMin;
	maxY = TableY + ItemHeight * NLinesMax;
	y = TableY + ItemHeight * NLines;
	break;
    case 2:	/* lower split bar */
	minY = commentY(3);
	maxY = ScreenY - 1;
	y = CommBottomY;
	break;
    default:
	minY = 0;
	maxY = 0;
	y = 0;
    }
    if (ey < minY) {
	ey = minY;
    } else if (maxY < ey) {
	ey = maxY;
    }
    if (e->eType == penDownEvent) {
	py = y;
	r.topLeft.y = py - 1;
	WinInvertRectangle(&r,0);
    } else if (e->eType == penMoveEvent && ey != py) {
	r.topLeft.y = ey - 1;
	if (ey <= py - r.extent.y || py + r.extent.y <= ey) {
	    WinInvertRectangle(&r,0);
	    r.topLeft.y = py - 1;
	    WinInvertRectangle(&r,0);
	} else if (ey < py) {
	    r.extent.y = py - ey;
	    WinInvertRectangle(&r,0);
	    r.topLeft.y += height;
	    WinInvertRectangle(&r,0);
	} else if (py < ey) {
	    r.extent.y = ey - py;
	    r.topLeft.y += height - r.extent.y;
	    WinInvertRectangle(&r,0);
	    r.topLeft.y -= height;
	    WinInvertRectangle(&r,0);
	}
	py = ey;
    } else if (e->eType == penUpEvent && py >= 0) {
	r.topLeft.y = py - 1;
	WinInvertRectangle(&r,0);
	switch (part) {
	case 1:		/* upper split bar */
	    if (NLines != (py - TableY + ItemHeight/2) / ItemHeight) {
		short old, new;
		old = NShowComments;
		NLines = (py - TableY + ItemHeight/2) / ItemHeight;
		new = NShowComments;
		if (new < old) {
		    TransNLines -= old - new;
		    if (TransNLines < 0) TransNLines = 0;
		}
		r.topLeft.x = TableRightX;
		r.extent.x = ScreenX - r.topLeft.x;
		r.topLeft.y = TableBottomY + 1;
		if (isLargeClockShown())
		    r.extent.y = LargeClockY - r.topLeft.y;
		else r.extent.y = CommBottomY - r.topLeft.y;
		WinEraseRectangle(&r,0);	/* notes scroll bar */
		drawTable();
	    }
	    break;
	case 2:		/* lower split bar */
	    if (TransNLines
		!= (ScreenY - py + CommentsHeight/2) / CommentsHeight) {
		drawLowerSplit(false);	/* erase previous bar */
		TransNLines
		    = (ScreenY - py + CommentsHeight/2) / CommentsHeight;
		drawLowerSplit(true);	/* draw bar */
		r.topLeft.x = TableRightX;
		r.extent.x = ScreenX - r.topLeft.x;
		r.topLeft.y = TableBottomY + 1;
		r.extent.y = ScreenY - r.extent.x;
		WinEraseRectangle(&r,0);
		if (TransNLines > 0) eraseLargeClock(false);
		DrawNotesFlag = true;
		drawTime(true);
	    }
	    break;
	}
	py = -1;
    }
    return true;
}

static Boolean pointInRect(RectanglePtr r, short x, short y) {
    return r->topLeft.x <= x && x < r->topLeft.x + r->extent.x
	&& r->topLeft.y <= y && y < r->topLeft.y + r->extent.y;
}

static Boolean handlePenAlarm(EventPtr e) {
    static Boolean on;
    if (e->eType == penDownEvent) {
	if (AlarmMinute >= 0) {
	    AlarmTapCount = -1;
	    drawAlarmTime();
	}
	WinInvertRectangle(&AlarmRect,0);
	on = true;
    } else if (e->eType == penMoveEvent) {
	if (pointInRect(&AlarmRect,e->screenX,e->screenY)) {
	    if (!on) {
		WinInvertRectangle(&AlarmRect,0);
		on = true;
	    }
	} else {
	    if (on) {
		WinInvertRectangle(&AlarmRect,0);
		on = false;
	    }
	}
    } else if (e->eType == penUpEvent) {
	if (AlarmTapCount < 0) AlarmTapCount = AlarmTapCountMax;
	if (on) {
	    WinInvertRectangle(&AlarmRect,0);
	    on = false;
	    if (AlarmMinute >= 0) {
		setAlarm(-1);
		WinDrawLine(AlarmRect.topLeft.x,AlarmRect.topLeft.y,
			    AlarmRect.topLeft.x + AlarmRect.extent.x - 1,
			    AlarmRect.topLeft.y + AlarmRect.extent.y - 1);
		WinDrawLine(AlarmRect.topLeft.x + AlarmRect.extent.x - 1,
			    AlarmRect.topLeft.y,
			    AlarmRect.topLeft.x,
			    AlarmRect.topLeft.y + AlarmRect.extent.y - 1);
	    } else if (AlarmMinuteSave >= 0 && setAlarm(AlarmMinuteSave)) {
		AlarmMinute = getAlarm();
		if (AlarmMinute >= 0) {
		    AlarmTapCount = AlarmTapCountMax;
		    drawAlarm();
		    drawAlarmTime();
		}
	    } else {
		popupAlarmDialog();
	    }
	}
    }
    return true;
}

static Boolean handleTablePen(EventPtr e) {
    static short part;
    short ex, ey;
    short x, y;
    ex = e->screenX;
    ey = e->screenY;
    if (e->eType == penDownEvent) {
	if (TableRightX <= ex
	    && TableBottomY - 2 <= ey && ey <= TableBottomY + 2) {
	    part = 5;		/* upper split bar */
#if 0
	} else if (!isLargeClockShown()
		   && TableRightX <= ex
		   && ((ScreenY <= CommBottomY && CommBottomY - 4 <= ey)
		       || (CommBottomY - 2 <= ey && ey <= CommBottomY + 2))) {
	    part = 6;		/* lower split bar */
#endif
	} else if (findItem(ex,ey,&x,&y)) {
	    part = 1;		/* timetable */
	} else if (LargeClockX < ex
		   && LargeClockY < ey
		   && isLargeClockShown()
		   && LargeClockFreq < Always) {
	    part = 2;		/* Large Clock */
	} else if (TableBottomY <= ey
		   && !(ShowArrivesFlag && CurrentTable->ArrivesLen > 0
			&& TableRightX <= ex)) {
	    part = 3;		/* Comments */
	} else if (!FrmPointInTitle(MainFormPtr,ex,ey)
		   && !(TableY <= ey && TableRightX <= ex)
		   && !pointInRect(&BackwardButtonRect,ex,ey)
		   && !pointInRect(&ForwardButtonRect,ex,ey)
		   && !(NarrowMode >= 0
			&& pointInRect(&NarrowPopupRect,ex,ey))) {
	    part = 4;		/* else where */
	    if (pointInRect(&AlarmRect,ex,ey)) {
		AlarmMinute = getAlarm();
		part = 7;
	    }
	} else {
	    part = -1;		/* events for the system */
	}
#ifdef DEBUG
	HostFPrintF(HostFp,"handleTablePen penDownEvent: (%d,%d) part %d\n",
		    ex,ey,part);
#endif
    }
    x = part;
    if (e->eType == penUpEvent) part = -1;
    switch (x) {
    case 1:	return handlePenTable(e);
    case 2:	return handlePenClock(e);
    case 3:	return handlePenComment(e);
    case 4:	return handlePenElse(e);
    case 5:	return handlePenSplit(e,1);
    case 6:	return handlePenSplit(e,2);
    case 7:	return handlePenAlarm(e);
    }
    return false;
}

static void openTable(void) {
    short i;
    RectangleType r;
#ifdef PROFILE
    HostFPrintF(HostFp,"openTable(void) %lu\n",TimGetTicks());
#endif
    FntSetFont(stdFont);
    FrmGetObjectBounds(MainFormPtr,FrmGetObjectIndex
		       (MainFormPtr,MainTimeTable),&r);
    ItemWidth = FntCharsWidth("00",2) + SpaceWidth;
    ItemHeight = FntCharHeight() + 1;
    TableX = r.topLeft.x;
    TopY = r.topLeft.y;
    if (NarrowMode >= 0) {
	TableY = TopY + ItemHeight;
	r.extent.y -= ItemHeight;
    } else {
	TableY = TopY;
    }
    NItems = r.extent.x / ItemWidth;
    if (NLines < 0 || LargeClockY <= TableY + ItemHeight * NLines)
	NLines = r.extent.y / ItemHeight;
    TimeWidth = FntCharsWidth("00:00:00",8);
    TimeHeight = FntCharHeight();
    TimeX = ScreenX - 3 - TimeWidth;
    TimeY = 1;
    TimeLeftX = 82;
    FntSetFont(boldFont);
    TimeLeftColonX = TimeLeftX + FntCharsWidth("00",2);
    BoldColonWidth = FntCharsWidth(":",1);
    NormalClockRect.topLeft.x = TimeLeftX;
    NormalClockRect.topLeft.y = TimeY;
    NormalClockRect.extent.x = FntCharsWidth("00:00",5);
    NormalClockRect.extent.y = FntLineHeight();
    FntSetFont(stdFont);
    AlarmRect.topLeft.x = TimeX - AlarmSize;
    AlarmRect.topLeft.y = 0;
    AlarmRect.extent.x = AlarmSize;
    AlarmRect.extent.y = AlarmSize;
    StnX = 0;
    StnXLower = 0;
    StnExtent = 0;
    for (i=0; i < NNumBitmaps; i++) {
	if (NumBitmap[i]) DmReleaseResource(NumBitmap[i]);
	NumBitmap[i] = DmGetResource('Tbmp',BitmapZero+i);
    }
    AlarmBitmap = DmGetResource('Tbmp',BitmapAlarm);
    CurrentMenuBar = MainMenuBar;
    ClockInvertedFlag = false;
    StopClock = 0;
    if (OffScreen) WinDeleteWindow(OffScreen,false);
    OffScreen = WinCreateOffscreenWindow(ScreenX,ItemHeight,
					 screenFormat,&OffScreenErr);
}

static void closeTable(void) {
    short i;
    unselectItem();
    if (NarrowOrgItemsText && MainFormPtr) {
	ListPtr list;
	Word lindex;
	lindex = FrmGetObjectIndex(MainFormPtr,MainPopupListNarrow);
	list = FrmGetObjectPtr(MainFormPtr,lindex);
	list->itemsText = NarrowOrgItemsText;
	list->numItems = NarrowOrgNumItems;
	list->bounds.extent.x = NarrowOrgItemWidth;
	NarrowOrgItemsText = NULL;
    }
    if (CurrentTable) {
	disposeTimeTable(CurrentTable);
	CurrentTable = NULL;
    }
    if (ArriveTime) {
	MemPtrFree(ArriveTime);
	ArriveTime = NULL;
    }
    for (i=0; i < NNumBitmaps; i++) {
	if (NumBitmap[i]) {
	    DmReleaseResource(NumBitmap[i]);
	    NumBitmap[i] = NULL;
	}
    }
    if (AlarmBitmap) DmReleaseResource(AlarmBitmap);
    if (OffScreen) {
	WinDeleteWindow(OffScreen,false);
	OffScreen = NULL;
    }
}


Boolean setTimeTable(long recordNum) {
#ifdef PROFILE
    HostFPrintF(HostFp,"setTimeTable(long recordNum) %lu\n",TimGetTicks());
#endif
    if (loadTrainTimeDB(recordNum)) {
#ifdef DEBUG
	HostFPrintF(HostFp,"History[HistoryCur]=%ld, recordNum=%ld\n",
		    History[HistoryCur],recordNum);
#endif
	if (History[HistoryCur] == recordNum) {
	    restoreHisAttr(HistoryCur);
	} else {
	    storeHistory(recordNum);
	    StopClock = 0;
	    unselectItem();
	}
	return true;
    }
    return false;
}

static void doDispPrefs(void) {
    Boolean underline = UnderlineSpecialFlag;
    Boolean omithour = OmitHourFlag;
    Boolean twelve = TwelveFlag;
    HeadType header = ArriveTimeHeadType;
    short column = ArrivesColumn;
    doDispPrefsDialog();
    if (LargeClockFreq == Never && LargeClockFlag) {
	LargeClockFlag = false;
	eraseLargeClock(true);
    } else if (LargeClockFreq == Always && !LargeClockFlag) {
	LargeClockFlag = true;
	DrawNotesFlag = true;	/* redraw comments area */
	drawTime(true);
    }
    if (column != ArrivesColumn) {
	if (ArriveTime) MemPtrFree(ArriveTime);
	ArriveTime = NULL;
	if (CurrentTable->ArrivesLen) {
	    ArriveTime = MemPtrNew(sizeof(short) * CurrentTable->ArrivesLen
				   * ArrivesColumn);
	    if (!ArriveTime) {
		PrivErrDisplay(PrivErrString(privErrNotEnoughSpace),true);
		CurrentTable->ArrivesLen = 0;
	    }
	}
    }
    if (!header && ArriveTimeHeadType > HeadNone
	&& CurrentTable->ArrivesLen <= NShowComments - 1) OfsArrive--;
    if (column != ArrivesColumn
	|| underline != UnderlineSpecialFlag
	|| omithour != OmitHourFlag
	|| header != ArriveTimeHeadType
	|| twelve != TwelveFlag) {
	DrawNotesFlag = true;	/* redraw comments area */
    }
    if (underline != UnderlineSpecialFlag || twelve != TwelveFlag) {
	drawTableTime();
	drawTime(true);
    }
    restartClock();
}

/* Handles Events */

FileMenuType *getFileMenuItem(ULong now, short item) {
    short offset = 0;
    if (BorderMin == -2) {
	offset = MENU_NITEMS;
    } else if (BorderMin >= 0) {
	DateTimeType dateTime;
	TimSecondsToDateTime(now,&dateTime);
	if (dateTime.hour <= MidNight	/* till 4:00 */
	    || BorderMin <= dateTime.hour * 60 + dateTime.minute)
	    offset = MENU_NITEMS;
    }
    return &FileMenu[offset+item];
}

static void modFileMenuItem(ULong now, Boolean force) {
    FileMenuType *menu = getFileMenuItem(now,0);
    static FileMenuType *prev = NULL;
    MenuItemType *item;
    short i;
    if (!force && prev == menu) return;
    item = MainMenuBar->menus[0].items;
    for (i=0; i < MENU_NITEMS; i++)
	item[FileMenuOne-FileMenuOpen+i].itemStr = menu[i].str;
    prev = menu;
}

void setFileMenuItem(ULong now, short item,
		     char *str, short len, long recordNum) {
    Boolean amFlag = false;
    Boolean pmFlag = false;
    DateTimeType dateTime;
    TimSecondsToDateTime(now,&dateTime);
    if (BorderMin >= 0) {
	if (dateTime.hour <= MidNight	/* till 4:00 */
	    || BorderMin <= dateTime.hour * 60 + dateTime.minute) {
	    pmFlag = true;
	} else {
	    amFlag = true;
	}
    }
    if (len >= MENU_LEN_MAX) len = MENU_LEN_MAX - 1;
    if (BorderMin == -1 || BorderMin == -3 || amFlag) {	/* AM */
	if (str) {
	    StrNCopy(FileMenu[item].str,str,len);
	    FileMenu[item].str[len] = '\0';
	}
	FileMenu[item].recordNum = recordNum;
    }
    if (BorderMin == -2 || BorderMin == -3 || pmFlag) {	/* PM */
	if (str) {
	    StrNCopy(FileMenu[MENU_NITEMS+item].str,str,len);
	    FileMenu[MENU_NITEMS+item].str[len] = '\0';
	}
	FileMenu[MENU_NITEMS+item].recordNum = recordNum;
    }
    modFileMenuItem(now, true);
}

Boolean MainFormHandleEvent(EventPtr e) {
    Boolean handled = false;
    ULong now;
    long record;
    FileMenuType *menu;
    static short prevBorderMin = 0;
    short item;
    FormPtr form;
    
    CALLBACK_PROLOGUE

    now = TimGetSeconds();
    if (now/60 != PrevTime/60
	|| BorderMin != prevBorderMin) {
	prevBorderMin = BorderMin;
	modFileMenuItem(now,false);
    }
    switch (e->eType) {
    case frmOpenEvent:
	form = MainFormPtr;
	MainFormPtr = FrmGetFormPtr(MainForm);
	if (MainFormPtr) {
	    openTable();
	    if ((ChooseStartupFlag && StartupFlag)
		|| TrainTimeRecordNum < 0
		|| (CurrentTable == NULL
		    && !setTimeTable(TrainTimeRecordNum))) {
		FrmGotoForm(TableListForm);
	    } else {
		FrmDrawForm(MainFormPtr);
		updateHistoryButton();
		drawTable();
	    }
	    if (form) FrmDeleteForm(form);
	    handled = true;
	} else {
	    MainFormPtr = form;
	}
	StartupFlag = false;
	break;
    case frmCloseEvent:
	CurrentMenuBar = NULL;
	handled = true;		/* don't delete MainFormPtr */
	break;
    case frmUpdateEvent:
	FrmDrawForm(MainFormPtr);
	drawTable();
	handled = true;
	break;
    case frmTitleSelectEvent:
	goto gotoList;
    case menuEvent:
	MenuEraseStatus(CurrentMenuBar);
	switch(e->data.menu.itemID) {
	case FileMenuOpen:
	gotoList:
	    putLRU();
	    saveHisAttr(HistoryCur);
	    closeTable();
	    FrmGotoForm(TableListForm);
	    handled = true;
	    break;
	case FileMenuBack:
	backward:
	    putLRU();
	    saveHisAttr(HistoryCur);
	    record = backHistory();
	    if (record < 0) break;
	    if (loadTrainTimeDB(record)) goto load;
	    HistoryBot = HistoryCur;	/* dispose bad DB */
	    forwardHistory();
	    updateHistoryButton();
	    break;
	case FileMenuForward:
	forward:
	    putLRU();
	    saveHisAttr(HistoryCur);
	    record = forwardHistory();
	    if (record < 0) break;
	    if (loadTrainTimeDB(record)) goto load;
	    backHistory();
	    HistoryTop = HistoryCur;	/* dispose bad DB */
	    updateHistoryButton();
	    break;
	case FileMenuOne:
	case FileMenuTwo:
	case FileMenuThree:
	case FileMenuFour:
	case FileMenuFive:
	case FileMenuSix:
	case FileMenuSeven:
	case FileMenuEight:
	    item = e->data.menu.itemID - FileMenuOne;
	timetable:
	    menu = getFileMenuItem(now,item);
	    if (menu->recordNum < 0) break;
	    if (!checkTitle(menu->recordNum,menu->str)) {
		record = searchFile(menu->str);
		if (record < 0) {
		    setFileMenuItem(now,item,"",0,-1);
		    break;
		}
		setFileMenuItem(now,item,NULL,0,record);
	    }
	    putLRU();
	    saveHisAttr(HistoryCur);
	    if (loadTrainTimeDB(menu->recordNum)) {
		storeHistory(menu->recordNum);
		StopClock = 0;
		unselectItem();
	    load:
		updateHistoryButton();
		drawTable();
		handled = true;
	    }
	    break;
	case FileMenuQuit:
	quit:
	    e->eType = appStopEvent;	/* leave main event loop */
	    break;
	case OptionsMenuAbout:
	    doAboutDialog();
	    handled = true;
	    break;
	case OptionsMenuDispPrefs:
	    doDispPrefs();
	    handled = true;
	    break;
	case OptionsMenuListPrefs:
	    doListPrefsDialog();
	    handled = true;
	    break;
	case OptionsMenuButtonPrefs:
	    doButtonPrefsDialog();
	    handled = true;
	    break;
	case OptionsMenuAlarm:
	alarm:
	    popupAlarmDialog();
	    handled = true;
	    break;
	case OptionsMenuNarrow:
	narrow:
	    if (NarrowMode < 0) {
		NarrowMode = -NarrowMode - 1;
		if (NarrowMode >= CurrentTable->NarrowsLen) NarrowMode = 0;
		if (NarrowMode > 0) {
		    putLRU();
		    loadTrainTimeDB(TrainTimeRecordNum);
		    unselectItem();
		}
		NLines--;
		TableY = TopY + ItemHeight;
	    } else {
		if (NarrowMode > 0) {
		    NarrowMode = -NarrowMode - 1;
		    putLRU();
		    loadTrainTimeDB(TrainTimeRecordNum);
		    unselectItem();
		} else {
		    NarrowMode = -1;
		}
		NLines++;
		TableY = TopY;
	    }
	    drawTable();
	    drawTime(true);
	    handled = true;
	    break;
	case OptionsMove:
	    record = moveRecord(TrainTimeRecordNum,NContFiles);
	    if (record >= 0) {
		shiftHistory(record);
		shiftLRU(record);
		History[HistoryCur] = TrainTimeRecordNum = record;
		LRU[LRU_Top].recordNum = record;
		updateOptionMenuItem();
	    }
	    handled = true;
	    break;
	case OptionsHoliday:
	    Today = Holiday;
	    goto setToday;
	case OptionsSunday:
	    Today = Sunday;
	    goto setToday;
	case OptionsSaturday:
	    Today = Saturday;
	    goto setToday;
	case OptionsWeekday:
	    Today = Weekday;
	setToday:
	    TodaySetSeconds = TimGetSeconds();
	    if (loadTrainTimeDB(TrainTimeRecordNum)) {
		unselectItem();
		drawTable();
		handled = true;
	    }
	    break;
	}
	break;
    case ctlSelectEvent:
	switch(e->data.ctlSelect.controlID) {
	case MainBackward:
	    goto backward;
	case MainForward:
	    goto forward;
	}
	break;
    case popSelectEvent:
	if (e->data.popSelect.listID == MainPopupListNarrow) {
	    short item = e->data.popSelect.selection;
	    if (0 <= item && item < CurrentTable->NarrowsLen
		&& item != NarrowMode) {
		NarrowMode = item;
		putLRU();
		if (loadTrainTimeDB(TrainTimeRecordNum)) {
		    unselectItem();
		    drawTable();
		    handled = true;
		}
	    }
	}
	break;
    case penDownEvent:
    case penMoveEvent:
    case penUpEvent:
	handled = handleTablePen(e);
	break;
    case keyDownEvent:
	if (e->data.keyDown.chr == pageUpChr) {
	    if (ScrollByKeyFlag) scrollTable(-1);
	    else scrollComments(-1);
	    handled = true;
	} else if (e->data.keyDown.chr == pageDownChr) {
	    if (ScrollByKeyFlag) scrollTable(1);
	    else scrollComments(1);
	    handled = true;
	} else if (e->data.keyDown.chr == backspaceChr) {
	    goto backward;
	} else if (e->data.keyDown.chr == spaceChr) {
	    goto forward;
	} else if (e->data.keyDown.chr == 'a' || e->data.keyDown.chr == 'A') {
	    goto alarm;
	} else if (e->data.keyDown.chr == 'n' || e->data.keyDown.chr == 'N') {
	    goto narrow;
	} else if (e->data.keyDown.chr == 't' || e->data.keyDown.chr == 'T') {
	    do1stTransfer();
	    handled = true;
	} else if ('1' <= e->data.keyDown.chr && e->data.keyDown.chr <= '8') {
	    item = e->data.keyDown.chr - '1';
	    goto timetable;
	} else if (e->data.keyDown.chr == periodChr) {
	    goto quit;
	} else if (ChrIsHardKey(e->data.keyDown.chr)
		   && now - PrevTime < 4) {	/* not power on */
	    goto quit;
	}
	break;
    case sclRepeatEvent:
	if (e->data.sclRepeat.scrollBarID == ArriveScrollBar) {
	    scrollArrive(e->data.sclRepeat.newValue - e->data.sclRepeat.value);
	} else {
	    scrollTable(e->data.sclRepeat.newValue - e->data.sclRepeat.value);
	}
	break;		/* handled must be false */
    case nilEvent:
	drawTime(false);
	break;
    default:
        break;
    }
    if (handled) LastSec = now;

    CALLBACK_EPILOGUE

    return handled;
}

void initializeTable(void) {
    short i;
#ifdef PROFILE
    HostFPrintF(HostFp,"initializeTable(void) %lu\n",TimGetTicks());
#endif
    CurrentTable = NULL;
    ArriveTime = NULL;
    NextTrain = 0;
    TicksPerSeconds = SysTicksPerSecond();
    for (i=0; i < NNumBitmaps; i++) NumBitmap[i] = NULL;
    AlarmBitmap = NULL;
    StartupFlag = true;
    MainFormPtr = NULL;
    AlarmDialogFlag = false;
    AlarmMinute = AlarmMinuteSave = getAlarm();
    NarrowOrgItemsText = NULL;
}

void initializeTableDefault(void) {
    initLRU();
}

void initializeTableAfterPrefs(void) {
    MainMenuBar = MenuInit(MainMenu);
    modFileMenuItem(TimGetSeconds(),true);
    CurrentMenuBar = NULL;
    OffScreen = NULL;
    MoveMenuItemStrH = NULL;
    NarrowMode = NarrowModeDefault;
}

void terminateTable(void) {
    closeTable();
    if (MainMenuBar) MenuDispose(MainMenuBar);
    if (MoveMenuItemStrH) {
	MemHandleUnlock(MoveMenuItemStrH);
	DmReleaseResource(MoveMenuItemStrH);
	MoveMenuItemStrH = NULL;
    }
    FrmSaveAllForms();
    FrmCloseAllForms();
}

void terminateTableBeforePrefs(void) {
    if (LRU[LRU_Top].recordNum == TrainTimeRecordNum) {
	putLRU();
	saveHisAttr(HistoryCur);
    }
}
